'From VisualWorks® NonCommercial, Release 7 of vendredi 14 juin 2002 on mercredi 27 novembre 2002 at 1:42:19'!


CormasNS.Models defineNameSpace: #Markets
	private: false
	imports: '
			private Smalltalk.*
			private CormasNS.Kernel.*
			'
	category: 'MarketsCategory'!


CormasNS.Models.Markets defineClass: #Markets_GP
	superclass: #{CormasNS.Kernel.AgentCommLocation}
	indexedType: #none
	private: false
	instanceVariableNames: 'nom stock achat vente lieu fonctionOffre listeGC aleaIndividuel marge '
	classInstanceVariableNames: ''
	imports: ''
	category: 'Cormas-Markets'!

CormasNS.Models.Markets.Markets_GP defineSharedVariable: #CurrentId
	private: false
	constant: false
	category: 'As yet unclassified'
	initializer: nil!

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!


!CormasNS.Models.Markets.Markets_GP class methodsFor: 'id'!

CurrentId
	^CurrentId isNil 
		ifTrue: [0] 
		ifFalse: [CurrentId]!

CurrentId: x
	^CurrentId := x! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!


!CormasNS.Models.Markets.Markets_GP methodsFor: 'init'!

init
	super init.
	self stock: OrderedCollection new.
	self achat: OrderedCollection new.
	self vente: OrderedCollection new.
	self fonctionOffre: OrderedCollection new.
	self listeGC: OrderedCollection new.
	self marge: 5.
	self mailBox: OrderedCollection new!

initId
	self id: (self class CurrentId: self class CurrentId + 1)! !

!CormasNS.Models.Markets.Markets_GP methodsFor: 'control'!

achatTotal
	| s |
	s := 0.
	self achat isEmpty ifFalse: [self achat do: [:c | s := s + c last]].
	^s!

lectureCommandes
	"Construire une collection vente pour le GP a partir des messages contrats reçus"

	| lesContrats |
	
	self vente: OrderedCollection new.
	mailBox isEmpty ifFalse: 
			[lesContrats := self mailBox select: [:m | m symbol = #contrat].
			lesContrats isEmpty
				ifFalse: [lesContrats do: [:a | self vente: a parametres]]].
	self mailBox: OrderedCollection new!

livraisonCM
	"Actualiser le stock en fonction des messages de type contrats reçus. Demarche en deux temps : 1. Construire une collection vente pour le GP a partir des messages contrats reçus. 2. Utiliser cette collection vente pour actualiser le stock du GP (operation de livraison)"

	| p aa lesContrats |
	self vente: OrderedCollection new.
	mailBox isEmpty ifFalse: 
			[lesContrats := self mailBox select: [:m | m symbol = #contrat].
			lesContrats do: [:a | self vente add: a parametres]].
	self mailBox: OrderedCollection new.
	self vente do: 
			[:a | 
			p := a first.
			aa := stock detect: [:c2 | c2 first = p] ifNone: [nil].
			aa isNil ifFalse: 
					[aa add: aa last - a last.
					aa remove: (aa at: 2)]]!

livraisonCm
	"Actualiser le stock du GP de son carnet de commandes (collection vente) : operation de livraison"

	| p aa cpt |

self vente isEmpty
		ifFalse: 
			[p := self vente first.
			cpt := 0.
			stock do: [:c | c first < p ifTrue: [cpt := cpt + c last]].
			stock removeAllSuchThat: [:c2 | c2 first < p].
			aa := stock detect: [:c3 | c3 first = p]
						ifNone: [nil].
			aa isNil ifFalse: [aa last > (self vente last - cpt)
					ifTrue: 
						[aa add: (aa last - (self vente last - cpt)).
						aa remove: (aa at: 2)]
					ifFalse: [stock remove: aa]]]!

receptionMarchandises
	"Actualiser les stocks du GP a partir de la collection achat"

	| p aa stockCopie |
	self stock isEmpty
		ifTrue: [self stock add: self achat]
		ifFalse: 
			[p := self achat first.
			stockCopie := OrderedCollection new.
			stockCopie := self stock.
			aa := stockCopie detect: [:c2 | c2 first = p] ifNone: [nil].
			aa isNil
				ifTrue: [stockCopie add: self achat]
				ifFalse: 
					[aa add: aa last + self achat last.
					aa remove: (aa at: 2)].
			stock := stockCopie asSortedCollection: [:a :b | a first < b first]].
	self achat: OrderedCollection new!

sendOfferCM
	"Lire la derniere bid reçue si elle existe, determiner la quantite a offrir, calculer le cout moyen associe a cette quantite et rajouter une marge fixe pour obtenir le prix, envoyer un message au GC avec ce couple P Q "

	| Qstar qCumulee qOfferteCm o position somme q p coutMoyen m2 |
	mailBox isEmpty ifFalse: 
			[self mailBox do: 
					[:m | 
					m symbol = #propositionAchat ifTrue: 
							[Qstar := m qD min: self stockTotal.
							qCumulee := 0.
							qOfferteCm := OrderedCollection new.
							self stock do: 
									[:c | 
									qCumulee := qCumulee + c last.
									o := OrderedCollection new.
									o add: c first.
									o add: qCumulee.
									qOfferteCm add: o].
							position := qOfferteCm detect: [:c | c last > Qstar] ifNone: [self stock size + 1].
							somme := 0.
							self stock do: 
									[:c | 
									(self stock indexOf: c) < position
										ifTrue: [somme := somme + (c first * c last)].
									(self stock indexOf: c) = position ifTrue: 
											[q := (qOfferteCm at: position - 1) last.
											p := (self stock at: position) first.
											somme := somme + ((Qstar - q) * p)]]].
					coutMoyen := somme / Qstar.
					m2 := Markets_Offer new.
					m2 sender: self.
					m2 receiver: m sender.
					m2 symbol: #offreVente.
					m2 offre: OrderedCollection new.
					m2 offre add: coutMoyen + marge.
					m2 offre add: Qstar.
					self sendMessageAsynchronously: m2]].
	self halt.
	mailBox := OrderedCollection new!

sendOfferCm
	| qCumulee qOfferteCm o m2 w m3 |
	
	mailBox isEmpty ifFalse: [self mailBox do: [:m | m symbol = #propositionAchat
				ifTrue: 
					[qCumulee := 0.
					qOfferteCm := OrderedCollection new.
					self stock isEmpty
						ifFalse: 
							[self stock
								do: 
									[:c | 
									qCumulee := qCumulee + c last.
									o := OrderedCollection new.
									o add: c first.
									o add: qCumulee.
									qOfferteCm add: o].
							w := OrderedCollection new.
							w := qOfferteCm detect: [:a | a last >= m qD]
										ifNone: [nil].
							w isNil
								ifTrue: 
									[m2 := Markets_Offer new.
									m2 sender: self.
									m2 receiver: m sender.
									m2 symbol: #offreVente.
									m2 offre: OrderedCollection new.
									m2 offre: qOfferteCm last.
									self sendMessageAsynchronously: m2]
								ifFalse: 
									[m3 := Markets_Offer new.
									m3 sender: self.
									m3 receiver: m sender.
									m3 symbol: #offreVente.
									m3 offre: OrderedCollection new.
									m3 offre add: w first.
									m3 offre add: m qD.
									self sendMessageAsynchronously: m3]]]]].
	self mailBox removeAllSuchThat: [:n | n symbol = #propositionAchat]!

stockTotal
	| s |
	s := 0.
	self stock isEmpty ifFalse: [self stock do: [:c | s := s + c last]].
	^s!

supplyCm
	"Creation d'une collection a partir de la collection stock avec les P et la Q cumulee. Il s'agit de la fonction d'offre associee a une tarification au Cm"

	| qCumulee o |
	self fonctionOffre: OrderedCollection new.
	qCumulee := 0.
	self stock do: 
			[:c | 
			qCumulee := qCumulee + c last.
			o := OrderedCollection new.
			o add: c first.
			o add: qCumulee.
			self fonctionOffre add: o]! !

!CormasNS.Models.Markets.Markets_GP methodsFor: 'accessing'!

achat
	^achat!

achat: anObject
	achat := anObject!

aleaIndividuel
	^aleaIndividuel!

aleaIndividuel: anObject
	aleaIndividuel := anObject!

fonctionOffre
	^fonctionOffre!

fonctionOffre: anObject
	fonctionOffre := anObject!

lieu
	^lieu!

lieu: anObject
	lieu := anObject!

listeGC
	^listeGC!

listeGC: anObject
	listeGC := anObject!

marge
	^marge!

marge: anObject
	marge := anObject!

nom
	^nom!

nom: anObject
	nom := anObject!

stock
	^stock!

stock: anObject
	stock := anObject!

vente
	^vente!

vente: anObject
	vente := anObject! !

!CormasNS.Models.Markets.Markets_GP methodsFor: 'pov'!

pov

^#gp! !

!CormasNS.Models.Markets.Markets_GP methodsFor: 'probes'!

premierPrix
	fonctionOffre isEmpty ifTrue: [^0] ifFalse: [^fonctionOffre first first]! !


CormasNS.Models.Markets defineClass: #Markets_GC
	superclass: #{CormasNS.Kernel.AgentCommLocation}
	indexedType: #none
	private: false
	instanceVariableNames: 'nom stock achat vente lieu listeGP coutMessage stockSouhaite fonctionOffre qD marge stockTotal lrChoisie '
	classInstanceVariableNames: ''
	imports: ''
	category: 'Cormas-Markets'!

CormasNS.Models.Markets.Markets_GC defineSharedVariable: #CurrentId
	private: false
	constant: false
	category: 'As yet unclassified'
	initializer: nil!

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!


!CormasNS.Models.Markets.Markets_GC class methodsFor: 'id'!

CurrentId
	^CurrentId isNil 
		ifTrue: [0] 
		ifFalse: [CurrentId]!

CurrentId: x
	^CurrentId := x! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!


!CormasNS.Models.Markets.Markets_GC methodsFor: 'init'!

init
	super init.
	self stock: OrderedCollection new.
	self achat: OrderedCollection new.
	self vente: OrderedCollection new.
	self fonctionOffre: OrderedCollection new.
	self coutMessage: 500.
	self lieu = #LC1 ifTrue: [self stockSouhaite: 2400].
	self lieu = #LC2 ifTrue: [self stockSouhaite: 2400].
	self listeGP: OrderedCollection new.
	self marge: 5.
	self stockTotal: 0.
	self mailBox: OrderedCollection new.
	self lrChoisie: nil.
	self qD: 0!

initId
	self id: (self class CurrentId: self class CurrentId + 1)! !

!CormasNS.Models.Markets.Markets_GC methodsFor: 'control'!

achatTotal
	| s |
	s := 0.
	self achat isEmpty ifFalse: [self achat do: [:c | s := s + c last]].
	^s!

choixLR
	"Tirage au sort d'une LR puis move to"

	| c |
	
	c := Cormas randomFrom: 1 to: 3.
	self lrChoisie: c!

livraisonCM

"A voir y compris pour le programme similaire de GP : comment actualiser le stock alors que le calcul des prix s'est fait a partir du cout moyen pondere auquel on a rajoute une marge fixe"	
| p aa |
	self vente do: 
			[:a | 
			p := a first.
			aa := stock detect: [:c2 | c2 first = p] ifNone: [nil].
			aa isNil ifFalse: 
					[aa add: aa last - a last.
					aa remove: (aa at: 2)]]!

livraisonCm
	| p aa cpt |
	
self vente isEmpty ifFalse: 
			[p := self vente first.
			cpt := 0.
			stock do: [:c | c first < p ifTrue: [cpt := cpt + c last]].
			stock removeAllSuchThat: [:c2 | c2 first < p].
			aa := stock detect: [:c3 | c3 first = p] ifNone: [nil].
			aa isNil ifFalse: 
					[aa last > (self vente last - cpt)
						ifTrue: 
							[aa add: aa last - (self vente last - cpt).
							aa remove: (aa at: 2)]
						ifFalse: [stock remove: aa]]]!

premierPrix
	fonctionOffre isEmpty ifTrue: [^0] ifFalse: [fonctionOffre first first]!

receptionMarchandises
	"Actualiser les stocks du GC a partir de la collection achat"

	| p aa stockCopie |
	
	self achat isEmpty ifFalse: 
			[stockCopie := OrderedCollection new.
			stockCopie := self stock.
			self achat do: 
					[:f | 
					p := f first.
					aa := stockCopie detect: [:c2 | c2 first = p] ifNone: [nil].
					aa isNil
						ifTrue: [stockCopie add: f]
						ifFalse: 
							[aa add: aa last + f last.
							aa remove: (aa at: 2)]].
			stockCopie size > 1
				ifFalse: [stock := stockCopie]
				ifTrue: [stock := stockCopie asSortedCollection: [:a :b | a first < b first]]].
	self achat: OrderedCollection new!

receptionMarchandises2
	"Actualiser les stocks du GP a partir de la collection achat"

	| p aa stockCopie |
	achat isEmpty ifFalse: 
			[self stock isEmpty
				ifTrue: [self stock add: self achat]
				ifFalse: 
					[p := self achat first.
					stockCopie := OrderedCollection new.
					stockCopie := self stock.
					aa := stockCopie detect: [:c2 | c2 first = p] ifNone: [nil].
					aa isNil
						ifTrue: [stockCopie add: self achat]
						ifFalse: 
							[aa add: aa last + self achat last.
							aa remove: (aa at: 2)].
					stock := stockCopie asSortedCollection: [:a :b | a first < b first]]].
	self achat: OrderedCollection new!

sendBid
	"to be completed"
"Calcul de la quantité souhaitée par difference entre stockSouhaite et stock"
| m |

	self qD: self stockSouhaite - (self stockTotal asFloat).

"Envoi d'un message a l'ensemble de ses GP"
	self qD > 0 ifTrue: [self listeGP do: 
			[:p | 
			m := Markets_Bid new.
			m sender: self.
			m receiver: p.
			m symbol: #propositionAchat.
			m qD: self qD.
			self sendMessageAsynchronously: m]]!

sendContract
	"Lire sa boite aux lettres et repondre aux differents GP. Si celui qui propose le prix le plus faible peut lui offrir qD il lui envoie un contrat et ne repond pas a l'autre. Sinon il envoie a celui qui propose le prix le plus faible un contrat avec la quantite maximale qu il peut offrir et envoie une bid a l autre pour la qResiduelle"

	| lesOffres lesOffresTriees m2 m3 qDResiduelle m4 |
	
self achat: OrderedCollection new.
	self qD <= 0 ifFalse: 
			[mailBox isEmpty ifFalse: 
					[lesOffres := self mailBox select: [:m | m symbol = #offreVente].
					lesOffres isEmpty ifFalse: 
							[lesOffresTriees := lesOffres asSortedCollection: [:a :b | a offre first < b offre first].
							lesOffresTriees first offre last >= self qD
								ifTrue: 
									[m2 := Markets_Contract new.
									m2 sender: self.
									m2 receiver: lesOffresTriees first sender.
									m2 symbol: #contrat.
									m2 parametres: OrderedCollection new.
									m2 parametres add: lesOffresTriees first offre first.
									m2 parametres add: self qD.
									self sendMessageAsynchronously: m2.
									self achat add: m2 parametres.
									self qD: 0]
								ifFalse: 
									[m4 := Markets_Contract new.
									m4 sender: self.
									m4 receiver: lesOffresTriees first sender.
									m4 symbol: #contrat.
									m4 parametres: OrderedCollection new.
									m4 parametres add: lesOffresTriees first offre first.
									m4 parametres add: lesOffresTriees first offre last.
									self sendMessageAsynchronously: m4.
									self achat add: m4 parametres.
									lesOffresTriees size > 1 ifTrue: [
									qDResiduelle := qD - lesOffresTriees first offre last.
									m3 := Markets_Bid new.
									m3 sender: self.
									m3 receiver: lesOffresTriees last sender.
									m3 symbol: #propositionAchat.
									m3 qD: qDResiduelle.
									self sendMessageAsynchronously: m3.
									self qD: qDResiduelle]]]]].
	self mailBox: OrderedCollection new!

sendContract2
	"Lire sa boite aux lettres et repondre aux differents GP avec lesquels il veut acheter, en leur 
	precisant la quantite"

	| lesOffres m2 |

	self qD <= 0 ifFalse: [mailBox isEmpty
			ifFalse: 
				[lesOffres := self mailBox detect: [:m | m symbol = #offreVente]
							ifNone: [nil].
				lesOffres isNil
					ifFalse: 
						[m2 := Markets_Contract new.
						m2 sender: self.
						m2 receiver: lesOffres sender.
						m2 symbol: #contrat.
						m2 parametres: OrderedCollection new.
						m2 parametres add: lesOffres offre first.
						m2 parametres add: (self qD min: lesOffres offre last).
						self sendMessageAsynchronously: m2.
						self achat add: m2 parametres]]].
	self mailBox: OrderedCollection new!

supplyCM
	

	"Construction de la fonction d'offre des GC a partir de leurs stocks"

	

	| qCumulee qOfferteCm o position somme q p coutMoyen Qmax q2 y |
	self fonctionOffre: OrderedCollection new.	

"Creation d'une collection a partir de la collection stock avec les P et la Q cumulee. Il s'agit de la fonction d'offre associee a une tarification au Cm"
	qCumulee := 0.
	qOfferteCm := OrderedCollection new.
	self stock do: 
			[:c | 
			qCumulee := qCumulee + c last.
			o := OrderedCollection new.
			o add: c first.
			o add: qCumulee.
			qOfferteCm add: o].	

"Creation d'un vecteur de Q allant de 1 a Qmax"
	Qmax := self stockTotal.
	q := OrderedCollection new.
	1 to: Qmax do: [:i | q add: i].	

"Pour chacune des Q de ce vecteur calculer le cout moyen pondere. Creer une collection de collection avec les Q et les couts moyens ponderes associes. Ajouter une marge fixe a ces couts et on a la fonction d'O"
	q do: 
			[:x | 
			position := qOfferteCm detect: [:c | c last > x] ifNone: [self stock size + 1].
			somme := 0.
			self stock do: 
					[:c | 
					(self stock indexOf: c) < position
						ifTrue: [somme := somme + (c first * c last)].
					(self stock indexOf: c) = position ifTrue: 
							[q2 := (qOfferteCm at: position - 1) last.
							p := (self stock at: position) first.
							somme := somme + ((x - q2) * p)]].
			coutMoyen := somme / x.
			y := OrderedCollection new.
			y add: coutMoyen + marge.
			y add: x.
			self fonctionOffre add: y].!

supplyCm
	"Creation d'une collection a partir de la collection stock avec les P et la Q cumulee. Il s'agit de la fonction d'offre associee a une tarification au Cm"

	| qCumulee o |
	self fonctionOffre: OrderedCollection new.
	qCumulee := 0.
	self stock do: 
			[:c | 
			qCumulee := qCumulee + c last.
			o := OrderedCollection new.
			o add: c first.
			o add: qCumulee.
			self fonctionOffre add: o]! !

!CormasNS.Models.Markets.Markets_GC methodsFor: 'accessing'!

achat
	^achat!

achat: anObject
	achat := anObject!

coutMessage
	^coutMessage!

coutMessage: anObject
	coutMessage := anObject!

fonctionOffre
	^fonctionOffre!

fonctionOffre: anObject
	fonctionOffre := anObject!

lieu
	^lieu!

lieu: anObject
	lieu := anObject!

listeGP
	^listeGP!

listeGP: anObject
	listeGP := anObject!

lrChoisie
	^lrChoisie!

lrChoisie: anObject
	lrChoisie := anObject!

marge
	^marge!

marge: anObject
	marge := anObject!

nom
	^nom!

nom: anObject
	nom := anObject!

qD
	^qD!

qD: anObject
	qD := anObject!

stock
	^stock!

stock: anObject
	stock := anObject!

stockSouhaite
	^stockSouhaite!

stockSouhaite: anObject
	stockSouhaite := anObject!

stockTotal1
	^stockTotal!

stockTotal: anObject
	stockTotal := anObject!

vente
	^vente!

vente: anObject
	vente := anObject! !

!CormasNS.Models.Markets.Markets_GC methodsFor: 'pov'!

pov

^#gc! !

!CormasNS.Models.Markets.Markets_GC methodsFor: 'probes'!

stockTotal
	| s |
	s := 0.
	self stock isEmpty ifFalse: [self stock do: [:c | s := s + c last]].
	^s! !


CormasNS.Models.Markets defineClass: #Markets_Bid
	superclass: #{CormasNS.Kernel.Msg}
	indexedType: #none
	private: false
	instanceVariableNames: 'qD '
	classInstanceVariableNames: ''
	imports: ''
	category: 'Cormas-Markets'!

!CormasNS.Models.Markets.Markets_Bid methodsFor: 'accessing'!

qD
	^qD!

qD: anObject
	qD := anObject! !


CormasNS.Models.Markets defineClass: #Markets_Contract
	superclass: #{CormasNS.Kernel.Msg}
	indexedType: #none
	private: false
	instanceVariableNames: 'contrat parametres '
	classInstanceVariableNames: ''
	imports: ''
	category: 'Cormas-Markets'!

!CormasNS.Models.Markets.Markets_Contract methodsFor: 'accessing'!

contrat
	^contrat!

contrat: anObject
	contrat := anObject!

parametres
	^parametres!

parametres: anObject
	parametres := anObject! !


CormasNS.Models.Markets defineClass: #Markets_Offer
	superclass: #{CormasNS.Kernel.Msg}
	indexedType: #none
	private: false
	instanceVariableNames: 'offre '
	classInstanceVariableNames: ''
	imports: ''
	category: 'Cormas-Markets'!

!CormasNS.Models.Markets.Markets_Offer methodsFor: 'accessing'!

offre
	^offre!

offre: anObject
	offre := anObject!

pO
	^pO!

pO: anObject
	pO := anObject!

qO
	^qO!

qO: anObject
	qO := anObject! !


CormasNS.Models.Markets defineClass: #Markets
	superclass: #{CormasNS.Kernel.CormasModel}
	indexedType: #none
	private: false
	instanceVariableNames: 'theMarkets_GPs theMarkets_Cells theMarkets_GCs prix rationnement stockGC stockGP stockGP1 stockGP2 stockGP3 stockGC1 stockGC2 prixGC1 prixGC2 rationnementGC1 rationnementGC2 prixMoyen variabilitePrix rationnementTotal rationnementTotal1 rationnementTotal2 listePrix listePrixLC1 listePrixLC2 mauvaiseAllocationLRLC mauvaiseAllocationLCLC '
	classInstanceVariableNames: ''
	imports: ''
	category: 'Cormas-Markets'!

!CormasNS.Models.Markets.Markets methodsFor: 'instance-creation'!

initAgents
	| f gp gc GPnonchoisis GPchoisisUneFois GPchoisisDeuxFois copieGC g GPchoisisTroisFois GPchoisisQuatreFois GPchoisisCinqFois GPchoisisSixFois |
	super initAgents.
	self theMarkets_Cells do: 
			[:c | 
			"Creation, nomination de 15 GP dans 3 LR"

			c id < 4
				ifTrue: 
					[c nom: ('LR' , c id printString) asSymbol.
					c type: #LR]
				ifFalse: 
					[c nom: ('LC' , (c id - 3) printString) asSymbol.
					c type: #LC].
			c initValeurs].
	1 to: 15
		do: 
			[:i | 
			f := Markets_GP new init.
			self theMarkets_GPs add: f.
			f nom: ('GP' , i printString) asSymbol.
			i < 6 ifTrue: [f moveTo: (self theMarkets_Cells at: 1)].
			(i between: 6 and: 10) ifTrue: [f moveTo: (self theMarkets_Cells at: 2)].
			i > 10 ifTrue: [f moveTo: (self theMarkets_Cells at: 3)].
			f lieu: f patch nom].
	self theMarkets_Cells do: 
			[:d | 
			"Attribution a chaque LR des GP qui y resident"

			d type = #LR ifTrue: 
					[gp := self theMarkets_GPs select: [:e | e patch = d].
					d grossistesResidents: gp]].
	1 to: 30
		do: 
			[:i | 
			"Creation, nomination de 30 GC dans 2 LC (15 + 15)"

			f := Markets_GC new.
			self theMarkets_GCs add: f.
			f nom: ('GC' , i printString) asSymbol.
			i < 16
				ifTrue: [f moveTo: (self theMarkets_Cells at: 4)]
				ifFalse: [f moveTo: (self theMarkets_Cells at: 5)].
			f lieu: f patch nom.
			f init].
	self theMarkets_Cells do: 
			[:d | 
			"Attribution a chaque LC des GC qui y resident"

			d type = #LC ifTrue: 
					[gc := self theMarkets_GCs select: [:e | e patch = d].
					d grossistesResidents: gc]].	

"Creer les reseaux. Ceci permet de remplir l'attribut listeGP des GC et listeGC des GP"
	GPnonchoisis := OrderedCollection new.
	GPchoisisUneFois := OrderedCollection new.
	GPchoisisDeuxFois := OrderedCollection new.
	GPchoisisTroisFois := OrderedCollection new.
	GPchoisisQuatreFois := OrderedCollection new.
	GPchoisisCinqFois := OrderedCollection new.
	GPchoisisSixFois := OrderedCollection new.
	copieGC := OrderedCollection new.
	copieGC addAll: self theMarkets_GCs.	
	1 to: 30
		do: 
			[:i | 
			g := Cormas randomFrom: 1 to: 31 - i.
			gc := copieGC at: g.
			GPnonchoisis := self theMarkets_GPs select: [:e | e listeGC size = 0].
			GPnonchoisis isEmpty
				ifFalse: 
					[gp := Cormas selectRandomlyFrom: GPnonchoisis.
					gc listeGP add: gp.
					gp listeGC add: gc.
					GPnonchoisis := self theMarkets_GPs select: [:e | e listeGC size = 0 & (e lieu ~= gp lieu)].
					GPnonchoisis isEmpty
						ifFalse: 
							[gp := Cormas selectRandomlyFrom: GPnonchoisis.
							gc listeGP add: gp.
							gp listeGC add: gc]
						ifTrue: 
							[GPchoisisUneFois := self theMarkets_GPs select: [:e | e listeGC size = 1 & (e lieu ~= gp lieu)].
							GPchoisisUneFois isEmpty
								ifFalse: 
									[gp := Cormas selectRandomlyFrom: GPchoisisUneFois.
									gc listeGP add: gp.
									gp listeGC add: gc]
								ifTrue: 
									[GPchoisisDeuxFois := self theMarkets_GPs select: [:e | e listeGC size = 2 & (e lieu ~= gp lieu)].
									GPchoisisDeuxFois isEmpty
										ifFalse: 
											[gp := Cormas selectRandomlyFrom: GPchoisisDeuxFois.
											gc listeGP add: gp.
											gp listeGC add: gc]
										ifTrue: [self halt]]]]
				ifTrue: 
					[GPchoisisUneFois := self theMarkets_GPs select: [:e | e listeGC size = 1].
					GPchoisisUneFois isEmpty
						ifFalse: 
							[gp := Cormas selectRandomlyFrom: GPchoisisUneFois.
							gc listeGP add: gp.
							gp listeGC add: gc.
							GPchoisisUneFois := self theMarkets_GPs select: [:e | e listeGC size = 1 & (e lieu ~= gp lieu)].
							GPchoisisUneFois isEmpty
								ifFalse: 
									[gp := Cormas selectRandomlyFrom: GPchoisisUneFois.
									gc listeGP add: gp.
									gp listeGC add: gc]
								ifTrue: 
									[GPchoisisDeuxFois := self theMarkets_GPs select: [:e | e listeGC size = 2 & (e lieu ~= gp lieu)].
									GPchoisisDeuxFois isEmpty
										ifFalse: 
											[gp := Cormas selectRandomlyFrom: GPchoisisDeuxFois.
											gc listeGP add: gp.
											gp listeGC add: gc]
										ifTrue: 
											[GPchoisisTroisFois := self theMarkets_GPs select: [:e | e listeGC size = 3 & (e lieu ~= gp lieu)].
											GPchoisisTroisFois isEmpty
												ifFalse: 
													[gp := Cormas selectRandomlyFrom: GPchoisisTroisFois.
													gc listeGP add: gp.
													gp listeGC add: gc]
												ifTrue: [self halt]]]]
						ifTrue: 
							[GPchoisisDeuxFois := self theMarkets_GPs select: [:e | e listeGC size = 2].
							GPchoisisDeuxFois isEmpty
								ifFalse: 
									[gp := Cormas selectRandomlyFrom: GPchoisisDeuxFois.
									gc listeGP add: gp.
									gp listeGC add: gc.
									GPchoisisDeuxFois := self theMarkets_GPs select: [:e | e listeGC size = 2 & (e lieu ~= gp lieu)].
									GPchoisisDeuxFois isEmpty
										ifFalse: 
											[gp := Cormas selectRandomlyFrom: GPchoisisDeuxFois.
											gc listeGP add: gp.
											gp listeGC add: gc]
										ifTrue: 
											[GPchoisisTroisFois := self theMarkets_GPs select: [:e | e listeGC size = 3 & (e lieu ~= gp lieu)].
											GPchoisisTroisFois isEmpty
												ifFalse: 
													[gp := Cormas selectRandomlyFrom: GPchoisisTroisFois.
													gc listeGP add: gp.
													gp listeGC add: gc]
												ifTrue: 
													[GPchoisisQuatreFois := self theMarkets_GPs select: [:e | e listeGC size = 4 & (e lieu ~= gp lieu)].
													GPchoisisQuatreFois isEmpty
														ifFalse: 
															[gp := Cormas selectRandomlyFrom: GPchoisisQuatreFois.
															gc listeGP add: gp.
															gp listeGC add: gc]
														ifTrue: [self halt]]]]
								ifTrue: 
									[GPchoisisTroisFois := self theMarkets_GPs select: [:e | e listeGC size = 3].
									GPchoisisTroisFois isEmpty
										ifFalse: 
											[gp := Cormas selectRandomlyFrom: GPchoisisTroisFois.
											gc listeGP add: gp.
											gp listeGC add: gc.
											GPchoisisTroisFois := self theMarkets_GPs select: [:e | e listeGC size = 3 & (e lieu ~= gp lieu)].
											GPchoisisTroisFois isEmpty
												ifFalse: 
													[gp := Cormas selectRandomlyFrom: GPchoisisTroisFois.
													gc listeGP add: gp.
													gp listeGC add: gc]
												ifTrue: 
													[GPchoisisQuatreFois := self theMarkets_GPs select: [:e | e listeGC size = 4 & (e lieu ~= gp lieu)].
													GPchoisisQuatreFois isEmpty
														ifFalse: 
															[gp := Cormas selectRandomlyFrom: GPchoisisQuatreFois.
															gc listeGP add: gp.
															gp listeGC add: gc]
														ifTrue: 
															[GPchoisisCinqFois := self theMarkets_GPs select: [:e | e listeGC size = 5 & (e lieu ~= gp lieu)].
															GPchoisisCinqFois isEmpty
																ifFalse: 
																	[gp := Cormas selectRandomlyFrom: GPchoisisCinqFois.
																	gc listeGP add: gp.
																	gp listeGC add: gc]
																ifTrue: [self halt]]]]
										ifTrue: 
											[GPchoisisQuatreFois := self theMarkets_GPs select: [:e | e listeGC size = 4].
											GPchoisisQuatreFois isEmpty
												ifFalse: 
													[gp := Cormas selectRandomlyFrom: GPchoisisQuatreFois.
													gc listeGP add: gp.
													gp listeGC add: gc.
													GPchoisisQuatreFois := self theMarkets_GPs select: [:e | e listeGC size = 4 & (e lieu ~= gp lieu)].
													GPchoisisQuatreFois isEmpty
														ifFalse: 
															[gp := Cormas selectRandomlyFrom: GPchoisisQuatreFois.
															gc listeGP add: gp.
															gp listeGC add: gc]
														ifTrue: 
															[GPchoisisCinqFois := self theMarkets_GPs select: [:e | e listeGC size = 5 & (e lieu ~= gp lieu)].
															GPchoisisCinqFois isEmpty
																ifFalse: 
																	[gp := Cormas selectRandomlyFrom: GPchoisisCinqFois.
																	gc listeGP add: gp.
																	gp listeGC add: gc]
																ifTrue: 
																	[GPchoisisSixFois := self theMarkets_GPs select: [:e | e listeGC size = 6 & (e lieu ~= gp lieu)].
																	GPchoisisSixFois isEmpty
																		ifFalse: 
																			[gp := Cormas selectRandomlyFrom: GPchoisisSixFois.
																			gc listeGP add: gp.
																			gp listeGC add: gc]
																		ifTrue: [self halt]]]]
												ifTrue: [self halt]]]]].
			copieGC remove: gc].! !

!CormasNS.Models.Markets.Markets methodsFor: 'init'!

init
	self initCells.
	self initAgents.
	self prix: 0.
	self initData.
	self rationnement: 0.
	self stockGC: 0.
	self stockGP: 0.
	self stockGP1: 0.
	self stockGP2: 0.
	self stockGP3: 0.
	self stockGC1: 0.
	self stockGC2: 0.
	self prixGC1: 0.
	self prixGC2: 0.
	self rationnementGC1: 0.
	self rationnementGC2: 0.
	self prixMoyen: 0.
	self variabilitePrix: 0.
	self rationnementTotal: 0.
	self rationnementTotal1: 0.
	self rationnementTotal2: 0.
	self listePrix: OrderedCollection new.
	self listePrixLC1: OrderedCollection new.
	self listePrixLC2: OrderedCollection new.
	self mauvaiseAllocationLRLC: 0.
	self mauvaiseAllocationLCLC: 0.! !

!CormasNS.Models.Markets.Markets methodsFor: 'procedures'!

export
	| l |
	l := List new.
	l add: #rationnementLC.
	l add: #prixLC1.
	self exportGlobalCharts: l inFile: 'toto.txt'! !

!CormasNS.Models.Markets.Markets methodsFor: 'control'!

evoluateBourseCm: t 
	"ACTUALISATION DU STOCK DES GP (APPROVISIONNEMENT EXOGENE)"

	| offreP2 p offreP cpt e y yy yyy Dresiduelle cpt2 j Oresiduelle taux l offreLC offreLCTriee fonctionOffreLC demandeTotale o prixEtudies toto cpt50 |
	self theMarkets_Cells do: [:a | a aleaZone: (Cormas randomFrom: 1 to: 9)].
	cpt50 := 0.
	self theMarkets_GPs do: 
			[:a | 
			a aleaIndividuel: (Cormas randomFrom: 1 to: 9).
			o := OrderedCollection new.
			o add: 250 - (10 * a patch aleaZone) - (10 * a aleaIndividuel).
			o add: 2400 + (160 * a patch aleaZone) + (160 * a aleaIndividuel).
			cpt50:= cpt50 + o last. 
			a achat: o.
			a receptionMarchandises].
	"premierGP := self theMarkets_GPs detect: [:a | a nom = #GP1].
	achat first
	cpt :=0.
	self listePrix add: prix. self listePrix do: [:a | cpt := cpt + a]. self prixMoyen: cpt / 100. 
	cpt :=0.
	self listePrix do: [:a | cpt := cpt + ((a - prixMoyen) * (a - prixMoyen))]. self variabilitePrix: (cpt / 100) sqrt.

	t = 100 ifTrue: ['Prix moyen dans les LC: ' , self prixMoyen asFloat printString printOn: Transcript. Transcript cr]."
	"'ApprovisionnementGP' , cpt50 asFloat printString printOn: Transcript. Transcript cr.
	cpt5 := 0.
	self theMarkets_GPs do: [:b | cpt5 := cpt5 + b stockTotal asFloat].
	self stockGP: cpt5.
	'StockGP' , self stockGP printString printOn: Transcript.
	Transcript cr."	


"PROCESSUS DE MARCHE ENTRE GP ET CONSOMMATEURS DES LC"	


"Determination des offres individuelles des GP"
	self theMarkets_GPs do: [:a | a supplyCm].	

"Determination de l'offre aggregee de l ensemble des GP"
	offreLC := OrderedCollection new.
	offreLCTriee := OrderedCollection new.
	fonctionOffreLC := OrderedCollection new.
	self theMarkets_GPs do: [:w | w stock do: [:v | offreLC add: v]].
	offreLCTriee := offreLC asSortedCollection: [:a :b | a first < b first].
	prixEtudies := OrderedCollection new.
	offreLCTriee do: 
			[:couple | 
			p := couple first.
			(prixEtudies includes: p) ifFalse: 
					[offreP := offreLCTriee select: [:c2 | c2 first <= p].
					cpt := 0.
					offreP do: [:d | cpt := cpt + d last].
					offreP2 := OrderedCollection new.
					offreP2 add: p.
					offreP2 add: cpt.
					fonctionOffreLC add: offreP2.
					prixEtudies add: p]].	

"Determination du prix d equilibre sur le marche (et eventuellement du rationnement si il y a un deficit 
	d offre)"
	demandeTotale := 0.
	rationnement := 0.
	self theMarkets_Cells do: [:f | demandeTotale := demandeTotale + f qD].
	e := fonctionOffreLC detect: [:g | g last >= demandeTotale] ifNone: [nil].
	e isNil
		ifFalse: [prix := e first]
		ifTrue: 
			[prix := fonctionOffreLC last first.
			rationnement := demandeTotale - fonctionOffreLC last last].	

"Determination des commandes des differents GP (collection vente) en fonction du prix d equilibre"
	self theMarkets_GPs do: [:u | u vente: OrderedCollection new].
	fonctionOffreLC last last <= demandeTotale
		ifTrue: 
			[self theMarkets_GPs do: 
					[:a | 
					a fonctionOffre isEmpty ifFalse: 
							[a vente add: prix.
							a vente add: a fonctionOffre last last]]]
		ifFalse: 
			[cpt := 0.
			self theMarkets_GPs do: 
					[:yx | 
					y := yx.
					yy := y fonctionOffre asSortedCollection: [:a :b | a first > b first].
					yyy := yy detect: [:z | z first < prix] ifNone: [nil].
					yyy isNil ifFalse: 
							[cpt := cpt + yyy last.
							y vente add: prix.
							y vente add: yyy last]].
			Dresiduelle := demandeTotale - cpt.
			cpt2 := 0.
			self theMarkets_GPs do: 
					[:d | 
					j := d stock detect: [:jj | jj first = prix] ifNone: [nil].
					j isNil ifFalse: [cpt2 := cpt2 + j last]].
			Oresiduelle := cpt2.
			Oresiduelle >= Dresiduelle ifTrue: 
					[taux := Dresiduelle / Oresiduelle.
					self theMarkets_GPs do: 
							[:k | 
							l := k stock detect: [:kk | kk first = prix] ifNone: [nil].
							l isNil ifFalse: 
									[k vente isEmpty
										ifTrue: 
											[k vente add: prix.
											k vente add: l last * taux]
										ifFalse: 
											[toto := k vente last.
											k vente: OrderedCollection new.
											k vente add: prix.
											k vente add: toto + (l last * taux)]]]]].
	"cpt15 := 0.
	self theMarkets_GPs
		do: [:a | a vente isEmpty ifFalse: [cpt15 := cpt15 + a vente last]].
	'Ventes des GP ' , cpt15 printString printOn: Transcript.
	Transcript cr."
	"Actualisation du stock des GP : operation de livraison"
	self theMarkets_GPs do: [:a | a vente isEmpty ifFalse: [a livraisonCm]].
	"cpt16 := 0.
	self theMarkets_GPs do: [:b | cpt16 := cpt16 + b stockTotal].
	'StockGP2 ' , cpt16 printString printOn: Transcript.
	Transcript cr."
	"'Prix' , prix printString printOn: Transcript.
	'Rationnement' , rationnement printString printOn: Transcript.
	Transcript cr."
	
	
	self rationnementTotal: self rationnementTotal + rationnement.
	cpt :=0.
	self listePrix add: prix. self listePrix do: [:a | cpt := cpt + a]. self prixMoyen: cpt / 100. 
	cpt :=0.
	self listePrix do: [:a | cpt := cpt + ((a - prixMoyen) * (a - prixMoyen))]. self variabilitePrix: (cpt / 100) sqrt.


	t = 100 ifTrue: [self prixMoyen asFloat printOn: Transcript. ' ; ' printString printOn: Transcript. self rationnementTotal asFloat printOn: Transcript. ' ; ' printString printOn: Transcript. self variabilitePrix asFloat printOn: Transcript. Transcript cr].


	Transcript flush.
	self updateData: t!

evoluateBourseCm: t nFois: n
	"ACTUALISATION DU STOCK DES GP (APPROVISIONNEMENT EXOGENE)"

	| offreP2 p offreP cpt e y yy yyy Dresiduelle cpt2 j Oresiduelle taux l offreLC offreLCTriee fonctionOffreLC demandeTotale o prixEtudies toto cpt50 file |
	self theMarkets_Cells do: [:a | a aleaZone: (Cormas randomFrom: 1 to: 9)].
	cpt50 := 0.
	self theMarkets_GPs do: 
			[:a | 
			a aleaIndividuel: (Cormas randomFrom: 1 to: 9).
			o := OrderedCollection new.
			o add: 250 - (10 * a patch aleaZone) - (10 * a aleaIndividuel).
			o add: 2400 + (160 * a patch aleaZone) + (160 * a aleaIndividuel).
			cpt50:= cpt50 + o last. 
			a achat: o.
			a receptionMarchandises].
	"premierGP := self theMarkets_GPs detect: [:a | a nom = #GP1].
	achat first
	cpt :=0.
	self listePrix add: prix. self listePrix do: [:a | cpt := cpt + a]. self prixMoyen: cpt / 100. 
	cpt :=0.
	self listePrix do: [:a | cpt := cpt + ((a - prixMoyen) * (a - prixMoyen))]. self variabilitePrix: (cpt / 100) sqrt.

	t = 100 ifTrue: ['Prix moyen dans les LC: ' , self prixMoyen asFloat printString printOn: Transcript. Transcript cr]."
	"'ApprovisionnementGP' , cpt50 asFloat printString printOn: Transcript. Transcript cr.
	cpt5 := 0.
	self theMarkets_GPs do: [:b | cpt5 := cpt5 + b stockTotal asFloat].
	self stockGP: cpt5.
	'StockGP' , self stockGP printString printOn: Transcript.
	Transcript cr."	


"PROCESSUS DE MARCHE ENTRE GP ET CONSOMMATEURS DES LC"	


"Determination des offres individuelles des GP"
	self theMarkets_GPs do: [:a | a supplyCm].	

"Determination de l'offre aggregee de l ensemble des GP"
	offreLC := OrderedCollection new.
	offreLCTriee := OrderedCollection new.
	fonctionOffreLC := OrderedCollection new.
	self theMarkets_GPs do: [:w | w stock do: [:v | offreLC add: v]].
	offreLCTriee := offreLC asSortedCollection: [:a :b | a first < b first].
	prixEtudies := OrderedCollection new.
	offreLCTriee do: 
			[:couple | 
			p := couple first.
			(prixEtudies includes: p) ifFalse: 
					[offreP := offreLCTriee select: [:c2 | c2 first <= p].
					cpt := 0.
					offreP do: [:d | cpt := cpt + d last].
					offreP2 := OrderedCollection new.
					offreP2 add: p.
					offreP2 add: cpt.
					fonctionOffreLC add: offreP2.
					prixEtudies add: p]].	

"Determination du prix d equilibre sur le marche (et eventuellement du rationnement si il y a un deficit 
	d offre)"
	demandeTotale := 0.
	rationnement := 0.
	self theMarkets_Cells do: [:f | demandeTotale := demandeTotale + f qD].
	e := fonctionOffreLC detect: [:g | g last >= demandeTotale] ifNone: [nil].
	e isNil
		ifFalse: [prix := e first]
		ifTrue: 
			[prix := fonctionOffreLC last first.
			rationnement := demandeTotale - fonctionOffreLC last last].	

"Determination des commandes des differents GP (collection vente) en fonction du prix d equilibre"
	self theMarkets_GPs do: [:u | u vente: OrderedCollection new].
	fonctionOffreLC last last <= demandeTotale
		ifTrue: 
			[self theMarkets_GPs do: 
					[:a | 
					a fonctionOffre isEmpty ifFalse: 
							[a vente add: prix.
							a vente add: a fonctionOffre last last]]]
		ifFalse: 
			[cpt := 0.
			self theMarkets_GPs do: 
					[:yx | 
					y := yx.
					yy := y fonctionOffre asSortedCollection: [:a :b | a first > b first].
					yyy := yy detect: [:z | z first < prix] ifNone: [nil].
					yyy isNil ifFalse: 
							[cpt := cpt + yyy last.
							y vente add: prix.
							y vente add: yyy last]].
			Dresiduelle := demandeTotale - cpt.
			cpt2 := 0.
			self theMarkets_GPs do: 
					[:d | 
					j := d stock detect: [:jj | jj first = prix] ifNone: [nil].
					j isNil ifFalse: [cpt2 := cpt2 + j last]].
			Oresiduelle := cpt2.
			Oresiduelle >= Dresiduelle ifTrue: 
					[taux := Dresiduelle / Oresiduelle.
					self theMarkets_GPs do: 
							[:k | 
							l := k stock detect: [:kk | kk first = prix] ifNone: [nil].
							l isNil ifFalse: 
									[k vente isEmpty
										ifTrue: 
											[k vente add: prix.
											k vente add: l last * taux]
										ifFalse: 
											[toto := k vente last.
											k vente: OrderedCollection new.
											k vente add: prix.
											k vente add: toto + (l last * taux)]]]]].
	"cpt15 := 0.
	self theMarkets_GPs
		do: [:a | a vente isEmpty ifFalse: [cpt15 := cpt15 + a vente last]].
	'Ventes des GP ' , cpt15 printString printOn: Transcript.
	Transcript cr."
	"Actualisation du stock des GP : operation de livraison"
	self theMarkets_GPs do: [:a | a vente isEmpty ifFalse: [a livraisonCm]].
	"cpt16 := 0.
	self theMarkets_GPs do: [:b | cpt16 := cpt16 + b stockTotal].
	'StockGP2 ' , cpt16 printString printOn: Transcript.
	Transcript cr."
	"'Prix' , prix printString printOn: Transcript.
	'Rationnement' , rationnement printString printOn: Transcript.
	Transcript cr."
	
	
	self rationnementTotal: self rationnementTotal + rationnement.
	cpt :=0.
	self listePrix add: prix. self listePrix do: [:a | cpt := cpt + a]. self prixMoyen: cpt / 100. 
	cpt :=0.
	self listePrix do: [:a | cpt := cpt + ((a - prixMoyen) * (a - prixMoyen))]. self variabilitePrix: (cpt / 100) sqrt.


	t = 100 ifTrue: [ 	file := ((Cormas dataPath: self class name)
				, 'frank.txt') asFilename appendStream.	 file nextPutAll: self prixMoyen asFloat printString,';' . file nextPutAll: self rationnementTotal asFloat printString,';' . file nextPutAll: self variabilitePrix asFloat printString.
	file nextPutAll: '\' withCRs. file close].


	Transcript flush.
	self updateData: t.!

evoluatePlacesCm: t 
	"I- ACTUALISATION DU STOCK DES GP (APPROVISIONNEMENT EXOGENE)"

	| GcLc1 offreP2 p offreP cpt place e y yy yyy Dresiduelle cpt2 j Oresiduelle taux l offreLC offreLCTriee fonctionOffreLC GcLc2 o prixEtudies cpt7 prix1 rationnement1 prix2 rationnement2 w v toto GP1 GP2 GP3 g cpt20 offreLR offreLRTriee fonctionOffreLR tauxRationnement rationnement3 prix3 GcLr prixMoyenLC1 variabilitePrixLC1 prixMoyenLC2 variabilitePrixLC2 cpt11 stockdesLC cpt30 cpt31 stockdesLR |
	cpt7 := 0.
	self theMarkets_Cells do: [:a | a aleaZone: (Cormas randomFrom: 1 to: 9)].
	self theMarkets_GPs do: 
			[:a | 
			a aleaIndividuel: (Cormas randomFrom: 1 to: 9).
			o := OrderedCollection new.
			o add: 250 - (10 * a patch aleaZone) - (10 * a aleaIndividuel).
			o add: 2400 + (160 * a patch aleaZone) + (160 * a aleaIndividuel).
			a achat: o.
			a lieu = #LR1 ifTrue: [cpt7 := cpt7 + a achat last].
			a receptionMarchandises].
	GP1 := self theMarkets_GPs select: [:z | z lieu = #LR1].
	GP2 := self theMarkets_GPs select: [:z | z lieu = #LR2].
	GP3 := self theMarkets_GPs select: [:z | z lieu = #LR3].
	"GP1 do: [:b | b achat isEmpty ifFalse: [cpt7 := cpt7 + b achat last]].
	'Approvisonnement des GP de LR1: ' , cpt7 asFloat printString
		printOn: Transcript.
	Transcript cr.
	cpt7 := 0.
	GP1 do: [:b | cpt7 := cpt7 + b stockTotal].
	'stock des GP de LR1 a la veille du jour de marche: '
		, cpt7 asFloat printString printOn: Transcript.
	Transcript cr."	

"II- PROCESSUS DE MARCHE ENTRE GP et GC"
	self theMarkets_GCs do: 
			[:a | 
			a choixLR.
			a leave.
			a moveTo: (self theMarkets_Cells at: a lrChoisie)].	

"****************************PROCESSUS DE MARCHE DANS LR1******************************************"	

"Determination de la D dans LR1"
	self theMarkets_GCs do: [:a | a qD: a stockSouhaite - (a stockTotal asFloat). a qD < 0 ifTrue: [a qD = 0]].
	place := self theMarkets_Cells detect: [:a | a nom = #LR1] ifNone: [nil].
	place isNil ifFalse: 
			[GcLr := self theMarkets_GCs select: [:b | b patch = place].
			GcLr isEmpty
				ifTrue: [place qD: 0]
				ifFalse: 
					[cpt20 := 0.
					GcLr do: [:a | cpt20 := cpt20 + a qD].
					place qD: cpt20]].
	place qD = 0 ifFalse: 
			["cpt7 := 0.
			GcLr do: [:b | cpt7 := cpt7 + b stockTotal].
			'stock des GC qui se sont rendus en LR1 au debut du jour de marche: '
				, cpt7 asFloat printString printOn: Transcript.
			Transcript cr."	


"Determination de l'O dans LR1"
			GP1 do: [:a | a supplyCm]. 
			offreLR := OrderedCollection new.
			offreLRTriee := OrderedCollection new.
			fonctionOffreLR := OrderedCollection new.
			GP1 do: 
					[:wx | 
					w := wx.
					w stock do: 
							[:vx | 
							v := vx.
							offreLR add: v]].
			offreLRTriee := offreLR asSortedCollection: [:a :b | a first < b first].
			prixEtudies := OrderedCollection new.
			offreLRTriee do: 
					[:couple | 
					p := couple first.
					(prixEtudies includes: p) ifFalse: 
							[offreP := offreLRTriee select: [:c2 | c2 first <= p].
							cpt := 0.
							offreP do: [:d | cpt := cpt + d last].
							offreP2 := OrderedCollection new.
							offreP2 add: p.
							offreP2 add: cpt.
							fonctionOffreLR add: offreP2.
							prixEtudies add: p]].	

"Determination du prix dans LR1 (et eventuellement du rationnement)"
			rationnement1 := 0.
			e := fonctionOffreLR detect: 
							[:gx | 
							g := gx.
							g last >= place qD]
						ifNone: [nil].
			e isNil
				ifFalse: [prix1 := e first]
				ifTrue: 
					[prix1 := fonctionOffreLR last first.
					rationnement1 := place qD - fonctionOffreLR last last].
			"'Prix de LR1: ' , prix1 printString printOn: Transcript.
			Transcript cr.
			'Rationnement de LR1: ' , rationnement1 asFloat printString printOn: Transcript.
			Transcript cr."	

"Determination des ventes des GP de LR1"
			GP1 do: [:u | u vente: OrderedCollection new].
			fonctionOffreLR last last <= place qD
				ifTrue: 
					[GP1 do: 
							[:a | 
							a fonctionOffre isEmpty ifFalse: 
									[a vente add: prix1.
									a vente add: a fonctionOffre last last]]]
				ifFalse: 
					[cpt := 0.
					GP1 do: 
							[:yx | 
							y := yx.
							yy := y fonctionOffre asSortedCollection: [:a :b | a first > b first].
							yyy := yy detect: [:z | z first < prix1] ifNone: [nil].
							yyy isNil ifFalse: 
									[cpt := cpt + yyy last.
									y vente add: prix1.
									y vente add: yyy last]].
					Dresiduelle := place qD - cpt.
					cpt2 := 0.
					GP1 do: 
							[:d | 
							j := d stock detect: [:jj | jj first = prix1] ifNone: [nil].
							j isNil ifFalse: [cpt2 := cpt2 + j last]].
					Oresiduelle := cpt2.
					Oresiduelle >= Dresiduelle ifTrue: 
							[taux := Dresiduelle / Oresiduelle. taux > 1 ifTrue: [self halt].
							GP1 do: 
									[:k | 
									l := k stock detect: [:kk | kk first = prix1] ifNone: [nil].
									l isNil ifFalse: 
											[k vente isEmpty
												ifTrue: 
													[k vente add: prix1.
													k vente add: l last * taux]
												ifFalse: 
													[toto := k vente last. 
													k vente: OrderedCollection new.
													k vente add: prix1.
													k vente add: toto + (l last * taux)]]]]].	

"Determination des achats des GC qui se sont rendus dans LR1"
			tauxRationnement := (place qD - rationnement1) / place qD.
			GcLr do: 
					[:a | 
					a achat: OrderedCollection new.
					a qD = 0 ifFalse: 
							[a achat add: prix1.
							a achat add: a qD * tauxRationnement]].
			"cpt7 := 0.
			GP1 do: [:a | a vente isEmpty ifFalse: [cpt7 := cpt7 + a vente last]].
			'ventes des GP de LR1: ' , cpt7 asFloat printString printOn: Transcript.
			Transcript cr.
			cpt7 := 0.
			GcLr do: [:a | a achat isEmpty ifFalse: [cpt7 := cpt7 + a achat last]].
			'achat des GC qui se sont rendus dans LR1: ' , cpt7 asFloat printString
				printOn: Transcript.
			Transcript cr."	


"Livraison des GP : actualisation des stocks des GP et des GC presents en LR1"
			GP1 do: [:a | a livraisonCm].
			GcLr do: [:a | a receptionMarchandises2].
			

			"cpt7 := 0.
			GP1 do: [:b | cpt7 := cpt7 + b stockTotal].
			'stock des GP de LR1 a la fin du jour de marche: '
				, cpt7 asFloat printString printOn: Transcript.
			Transcript cr.
			cpt7 := 0.
			GcLr do: [:b | cpt7 := cpt7 + b stockTotal].
			'stock des GC qui se sont rendus en LR1 a la fin du jour de marche: '
				, cpt7 asFloat printString printOn: Transcript.
			Transcript cr"].	

"****************************PROCESSUS DE MARCHE DANS LR2******************************************"	

"Determination de la D dans LR2"
	place := self theMarkets_Cells detect: [:a | a nom = #LR2] ifNone: [nil].
	place isNil ifFalse: 
			[GcLr := self theMarkets_GCs select: [:b | b patch = place].
			GcLr isEmpty
				ifTrue: [place qD: 0]
				ifFalse: 
					[cpt20 := 0.
					GcLr do: [:a | cpt20 := cpt20 + a qD].
					place qD: cpt20]].
	place qD = 0 ifFalse: 
			["cpt7 := 0.
			GcLr do: [:b | cpt7 := cpt7 + b stockTotal].
			'stock des GC qui se sont rendus en LR2 au debut du jour de marche: '
				, cpt7 asFloat printString printOn: Transcript.
			Transcript cr."	

"Determination de l'O dans LR2"
			GP2 do: [:a | a supplyCm].
			offreLR := OrderedCollection new.
			offreLRTriee := OrderedCollection new.
			fonctionOffreLR := OrderedCollection new.
			GP2 do: 
					[:wx | 
					w := wx.
					w stock do: 
							[:vx | 
							v := vx.
							offreLR add: v]].
			offreLRTriee := offreLR asSortedCollection: [:a :b | a first < b first].
			prixEtudies := OrderedCollection new.
			offreLRTriee do: 
					[:couple | 
					p := couple first.
					(prixEtudies includes: p) ifFalse: 
							[offreP := offreLRTriee select: [:c2 | c2 first <= p].
							cpt := 0.
							offreP do: [:d | cpt := cpt + d last].
							offreP2 := OrderedCollection new.
							offreP2 add: p.
							offreP2 add: cpt.
							fonctionOffreLR add: offreP2.
							prixEtudies add: p]].	

"Determination du prix dans LR2 (et eventuellement du rationnement)"
			rationnement2 := 0.
			e := fonctionOffreLR detect: 
							[:gx | 
							g := gx.
							g last >= place qD]
						ifNone: [nil].
			e isNil
				ifFalse: [prix2 := e first]
				ifTrue: 
					[prix2 := fonctionOffreLR last first.
					rationnement2 := place qD - fonctionOffreLR last last].
			"'Prix de LR2: ' , prix2 printString printOn: Transcript.
			Transcript cr.
			'Rationnement de LR2: ' , rationnement2 asFloat printString printOn: Transcript.
			Transcript cr."	

"Determination des ventes des GP de LR2"
			GP2 do: [:u | u vente: OrderedCollection new].
			fonctionOffreLR last last <= place qD
				ifTrue: 
					[GP2 do: 
							[:a | 
							a fonctionOffre isEmpty ifFalse: 
									[a vente add: prix2.
									a vente add: a fonctionOffre last last]]]
				ifFalse: 
					[cpt := 0.
					GP2 do: 
							[:yx | 
							y := yx.
							yy := y fonctionOffre asSortedCollection: [:a :b | a first > b first].
							yyy := yy detect: [:z | z first < prix2] ifNone: [nil].
							yyy isNil ifFalse: 
									[cpt := cpt + yyy last.
									y vente add: prix2.
									y vente add: yyy last]].
					Dresiduelle := place qD - cpt.
					cpt2 := 0.
					GP2 do: 
							[:d | 
							j := d stock detect: [:jj | jj first = prix2] ifNone: [nil].
							j isNil ifFalse: [cpt2 := cpt2 + j last]].
					Oresiduelle := cpt2.
					Oresiduelle >= Dresiduelle ifTrue: 
							[taux := Dresiduelle / Oresiduelle. taux > 1 ifTrue: [self halt].
							GP2 do: 
									[:k | 
									l := k stock detect: [:kk | kk first = prix2] ifNone: [nil].
									l isNil ifFalse: 
											[k vente isEmpty
												ifTrue: 
													[k vente add: prix2.
													k vente add: l last * taux]
												ifFalse: 
													[toto := k vente last.
													k vente: OrderedCollection new.
													k vente add: prix2.
													k vente add: toto + (l last * taux)]]]]].	


"Determination des achats des GC qui se sont rendus dans LR2"
			tauxRationnement := (place qD - rationnement2) / place qD.
			GcLr do: 
					[:a | 
					a achat: OrderedCollection new.
					a qD = 0 ifFalse: 
							[a achat add: prix2.
							a achat add: a qD * tauxRationnement]].
			"cpt7 := 0.
			GP2 do: [:a | a vente isEmpty ifFalse: [cpt7 := cpt7 + a vente last]].
			'ventes des GP de LR2: ' , cpt7 asFloat printString printOn: Transcript.
			Transcript cr.
			cpt7 := 0.
			GcLr do: [:a | a achat isEmpty ifFalse: [cpt7 := cpt7 + a achat last]].
			'achat des GC qui se sont rendus dans LR2: ' , cpt7 asFloat printString
				printOn: Transcript.
			Transcript cr."	

"Livraison des GP : actualisation des stocks des GP et des GC presents en LR2"
			GP2 do: [:a | a livraisonCm].
			GcLr do: [:a | a receptionMarchandises2].
			"cpt7 := 0.
			GP2 do: [:b | cpt7 := cpt7 + b stockTotal].
			'stock des GP de LR2 a la fin du jour de marche: '
				, cpt7 asFloat printString printOn: Transcript.
			Transcript cr.
			cpt7 := 0.
			GcLr do: [:b | cpt7 := cpt7 + b stockTotal].
			'stock des GC qui se sont rendus en LR2 a la fin du jour de marche: '
				, cpt7 asFloat printString printOn: Transcript.
			Transcript cr"].

"****************************PROCESSUS DE MARCHE DANS LR3******************************************"	

"Determination de la D dans LR3"
	self theMarkets_GCs do: [:a | a qD: a stockSouhaite - a stockTotal].
	place := self theMarkets_Cells detect: [:a | a nom = #LR3] ifNone: [nil].
	place isNil ifFalse: 
			[GcLr := self theMarkets_GCs select: [:b | b patch = place].
			GcLr isEmpty
				ifTrue: [place qD: 0]
				ifFalse: 
					[cpt20 := 0.
					GcLr do: [:a | cpt20 := cpt20 + a qD].
					place qD: cpt20]].
	place qD = 0 ifFalse: 
			["cpt7 := 0.
			GcLr do: [:b | cpt7 := cpt7 + b stockTotal].
			'stock des GC qui se sont rendus en LR3 au debut du jour de marche: '
				, cpt7 asFloat printString printOn: Transcript.
			Transcript cr."	


"Determination de l'O dans LR3"
			GP3 do: [:a | a supplyCm].
			offreLR := OrderedCollection new.
			offreLRTriee := OrderedCollection new.
			fonctionOffreLR := OrderedCollection new.
			GP3 do: 
					[:wx | 
					w := wx.
					w stock do: 
							[:vx | 
							v := vx.
							offreLR add: v]].
			offreLRTriee := offreLR asSortedCollection: [:a :b | a first < b first].
			prixEtudies := OrderedCollection new.
			offreLRTriee do: 
					[:couple | 
					p := couple first.
					(prixEtudies includes: p) ifFalse: 
							[offreP := offreLRTriee select: [:c2 | c2 first <= p].
							cpt := 0.
							offreP do: [:d | cpt := cpt + d last].
							offreP2 := OrderedCollection new.
							offreP2 add: p.
							offreP2 add: cpt.
							fonctionOffreLR add: offreP2.
							prixEtudies add: p]].	

"Determination du prix dans LR3 (et eventuellement du rationnement)"
			rationnement3 := 0.
			e := fonctionOffreLR detect: 
							[:gx | 
							g := gx.
							g last >= place qD]
						ifNone: [nil].
			e isNil
				ifFalse: [prix3 := e first]
				ifTrue: 
					[prix3 := fonctionOffreLR last first.
					rationnement3 := place qD - fonctionOffreLR last last].
			"'Prix de LR3: ' , prix3 printString printOn: Transcript.
			Transcript cr.
			'Rationnement de LR3: ' , rationnement3 asFloat printString
				printOn: Transcript.
			Transcript cr."	

"Determination des ventes des GP de LR3"
			GP3 do: [:u | u vente: OrderedCollection new].
			fonctionOffreLR last last <= place qD
				ifTrue: 
					[GP3 do: 
							[:a | 
							a fonctionOffre isEmpty ifFalse: 
									[a vente add: prix3.
									a vente add: a fonctionOffre last last]]]
				ifFalse: 
					[cpt := 0.
					GP3 do: 
							[:yx | 
							y := yx.
							yy := y fonctionOffre asSortedCollection: [:a :b | a first > b first].
							yyy := yy detect: [:z | z first < prix3] ifNone: [nil].
							yyy isNil ifFalse: 
									[cpt := cpt + yyy last.
									y vente add: prix3.
									y vente add: yyy last]].
					Dresiduelle := place qD - cpt.
					cpt2 := 0.
					GP3 do: 
							[:d | 
							j := d stock detect: [:jj | jj first = prix3] ifNone: [nil].
							j isNil ifFalse: [cpt2 := cpt2 + j last]].
					Oresiduelle := cpt2.
					Oresiduelle >= Dresiduelle ifTrue: 
							[taux := Dresiduelle / Oresiduelle. taux > 1 ifTrue: [self halt].
							GP3 do: 
									[:k | 
									l := k stock detect: [:kk | kk first = prix3] ifNone: [nil].
									l isNil ifFalse: 
											[k vente isEmpty
												ifTrue: 
													[k vente add: prix3.
													k vente add: l last * taux]
												ifFalse: 
													[toto := k vente last.
													k vente: OrderedCollection new.
													k vente add: prix3.
													k vente add: toto + (l last * taux)]]]]].	

"Determination des achats des GC qui se sont rendus dans LR3"
			tauxRationnement := (place qD - rationnement3) / place qD.
			GcLr do: 
					[:a | 
					a achat: OrderedCollection new.
					a qD = 0 ifFalse: 
							[a achat add: prix3.
							a achat add: a qD * tauxRationnement]].
			"cpt7 := 0.
			GP3 do: [:a | a vente isEmpty ifFalse: [cpt7 := cpt7 + a vente last]].
			'ventes des GP de LR3: ' , cpt7 asFloat printString printOn: Transcript.
			Transcript cr.
			cpt7 := 0.
			GcLr do: [:a | a achat isEmpty ifFalse: [cpt7 := cpt7 + a achat last]].
			'achat des GC qui se sont rendus dans LR3: ' , cpt7 asFloat printString
				printOn: Transcript.
			Transcript cr."	

"Livraison des GP : actualisation des stocks des GP et des GC presents en LR3"
			GP3 do: [:a | a livraisonCm].
			GcLr do: [:a | a receptionMarchandises2].
			"cpt7 := 0.
			GP3 do: [:b | cpt7 := cpt7 + b stockTotal].
			'stock des GP de LR3 a la fin du jour de marche: '
				, cpt7 asFloat printString printOn: Transcript.
			Transcript cr.
			cpt7 := 0.
			GcLr do: [:b | cpt7 := cpt7 + b stockTotal].
			'stock des GC qui se sont rendus en LR3 a la fin du jour de marche: '
				, cpt7 asFloat printString printOn: Transcript.
			Transcript cr"].

"III- PROCESSUS DE MARCHE EN AVAL DES GC (DANS LES LC)"	

"Determination des offres individuelles des GP"
	self theMarkets_GCs do: [:a | a supplyCm].	

"Determination de la fonction d'offre de LC1"
	GcLc1 := self theMarkets_GCs select: [:z | z lieu = #LC1].
	offreLC := OrderedCollection new.
	offreLCTriee := OrderedCollection new.
	fonctionOffreLC := OrderedCollection new.
	GcLc1 do: 
			[:wx | 
			w := wx.
			w stock do: 
					[:vx | 
					v := vx.
					offreLC add: v]].
	offreLCTriee := offreLC asSortedCollection: [:a :b | a first < b first].
	prixEtudies := OrderedCollection new.
	offreLCTriee do: 
			[:couple | 
			p := couple first.
			(prixEtudies includes: p) ifFalse: 
					[offreP := offreLCTriee select: [:c2 | c2 first <= p].
					cpt := 0.
					offreP do: [:d | cpt := cpt + d last].
					offreP2 := OrderedCollection new.
					offreP2 add: p.
					offreP2 add: cpt.
					fonctionOffreLC add: offreP2.
					prixEtudies add: p]].	

"Determination du prix d'equilibre de LC1 (et eventuellement du rationnement) en utilisant une fonction 
	de D exogene"
	rationnement1 := 0.
	place := self theMarkets_Cells detect: [:f | f nom = #LC1].
	e := fonctionOffreLC detect: 
					[:gx | 
					g := gx.
					g last >= place qD]
				ifNone: [nil].
	e isNil
		ifFalse: [prix1 := e first]
		ifTrue: 
			[prix1 := fonctionOffreLC last first.
			rationnement1 := place qD - fonctionOffreLC last last].	

"Determination des commandes des GC de LC1 (collection vente) a partir du prix d''equilibre"
	GcLc1 do: [:u | u vente: OrderedCollection new].
	fonctionOffreLC last last <= place qD
		ifTrue: 
			[GcLc1 do: 
					[:a | 
					a fonctionOffre isEmpty ifFalse: 
							[a vente add: prix1.
							a vente add: a fonctionOffre last last]]]
		ifFalse: 
			[cpt := 0.
			GcLc1 do: 
					[:yx | 
					y := yx.
					yy := y fonctionOffre asSortedCollection: [:a :b | a first > b first].
					yyy := yy detect: [:z | z first < prix1] ifNone: [nil].
					yyy isNil ifFalse: 
							[cpt := cpt + yyy last.
							y vente add: prix1.
							y vente add: yyy last]].
			Dresiduelle := place qD - cpt.
			cpt2 := 0.
			GcLc1 do: 
					[:d | 
					j := d stock detect: [:jj | jj first = prix1] ifNone: [nil].
					j isNil ifFalse: [cpt2 := cpt2 + j last]].
			Oresiduelle := cpt2.
			Oresiduelle >= Dresiduelle ifTrue: 
					[taux := Dresiduelle / Oresiduelle. taux > 1 ifTrue: [self halt].
					GcLc1 do: 
							[:k | 
							l := k stock detect: [:kk | kk first = prix1] ifNone: [nil].
							l isNil ifFalse: 
									[k vente isEmpty
										ifTrue: 
											[k vente add: prix1.
											k vente add: l last * taux]
										ifFalse: 
											[toto := k vente last.
											k vente: OrderedCollection new.
											k vente add: prix1.
											k vente add: toto + (l last * taux)]]]]].	

"Determination de la fonction d'offre de LC2"
	GcLc2 := self theMarkets_GCs select: [:z | z lieu = #LC2].
	offreLC := OrderedCollection new.
	offreLCTriee := OrderedCollection new.
	fonctionOffreLC := OrderedCollection new.
	GcLc2 do: 
			[:wx | 
			w := wx.
			w stock do: 
					[:vx | 
					v := vx.
					offreLC add: v]].
	offreLCTriee := offreLC asSortedCollection: [:a :b | a first < b first].
	prixEtudies := OrderedCollection new.
	offreLCTriee do: 
			[:couple | 
			p := couple first.
			(prixEtudies includes: p) ifFalse: 
					[offreP := offreLCTriee select: [:c2 | c2 first <= p].
					cpt := 0.
					offreP do: [:d | cpt := cpt + d last].
					offreP2 := OrderedCollection new.
					offreP2 add: p.
					offreP2 add: cpt.
					fonctionOffreLC add: offreP2.
					prixEtudies add: p]].	

"Determination du prix d'equilibre de LC2 (et eventuellement du rationnement)"
	rationnement2 := 0.
	place := self theMarkets_Cells detect: [:f | f nom = #LC2].
	e := fonctionOffreLC detect: 
					[:gx | 
					g := gx.
					g last >= place qD]
				ifNone: [nil].
	e isNil
		ifFalse: [prix2 := e first]
		ifTrue: 
			[prix2 := fonctionOffreLC last first.
			rationnement2 := place qD - fonctionOffreLC last last].	

"Determination des commandes des GC de LC2 (collection vente) a partir du prix d''equilibre"
	GcLc2 do: [:u | u vente: OrderedCollection new].
	fonctionOffreLC last last <= place qD
		ifTrue: 
			[GcLc2 do: 
					[:a | 
					a fonctionOffre isEmpty ifFalse: 
							[a vente add: prix2.
							a vente add: a fonctionOffre last last]]]
		ifFalse: 
			[cpt := 0.
			GcLc2 do: 
					[:yx | 
					y := yx.
					yy := y fonctionOffre asSortedCollection: [:a :b | a first > b first].
					yyy := yy detect: [:z | z first < prix2] ifNone: [nil].
					yyy isNil ifFalse: 
							[cpt := cpt + yyy last.
							y vente add: prix2.
							y vente add: yyy last]].
			Dresiduelle := place qD - cpt.
			cpt2 := 0.
			GcLc2 do: 
					[:d | 
					j := d stock detect: [:jj | jj first = prix2] ifNone: [nil].
					j isNil ifFalse: [cpt2 := cpt2 + j last]].
			Oresiduelle := cpt2.
			Oresiduelle >= Dresiduelle ifTrue: 
					[taux := Dresiduelle / Oresiduelle. taux > 1 ifTrue: [self halt].
					GcLc2 do: 
							[:k | 
							l := k stock detect: [:kk | kk first = prix2] ifNone: [nil].
							l isNil ifFalse: 
									[k vente isEmpty
										ifTrue: 
											[k vente add: prix2.
											k vente add: l last * taux]
										ifFalse: 
											[toto := k vente last.
											k vente: OrderedCollection new.
											k vente add: prix2.
											k vente add: toto + (l last * taux)]]]]].
	"cpt15 := 0.
	GcLc1 do: [:a | a vente isEmpty ifFalse: [cpt15 := cpt15 + a vente last]].
	'Ventes des GC de LC1: ' , cpt15 asFloat printString printOn: Transcript.
	Transcript cr.
	cpt15 := 0.
	GcLc2 do: [:a | a vente isEmpty ifFalse: [cpt15 := cpt15 + a vente last]].
	'Ventes des GC de LC2: ' , cpt15 asFloat printString printOn: Transcript.
	Transcript cr.
	cpt15 := 0.
	self theMarkets_GCs
		do: [:a | a vente isEmpty ifFalse: [cpt15 := cpt15 + a vente last]].
	'Ventes des GC: ' , cpt15 asFloat printString printOn: Transcript.
	Transcript cr."	

"Livraison des GC ie actualisation de leur stock"
	self theMarkets_GCs do: [:a | a livraisonCm].	


"Sorties graphiques et ecran"
	"'Prix de LC1: ' , prix1 asFloat printString printOn: Transcript.
	Transcript cr.
	'Rationnement de LC1: ' , rationnement1 asFloat printString
		printOn: Transcript.
	Transcript cr.
	cpt11 := 0.
	GcLc1 do: [:b | cpt11 := cpt11 + b stockTotal].
	self stockGC1: cpt11.
	'Stock des GC de LC1 apres ventes de la semaine: '
		, cpt11 asFloat printString printOn: Transcript.
	Transcript cr.
	'Prix de LC2: ' , prix2 asFloat printString printOn: Transcript.
	Transcript cr.
	'Rationnement de LC2: ' , rationnement2 asFloat printString
		printOn: Transcript.
	Transcript cr.
	cpt11 := 0.
	GcLc2 do: [:b | cpt11 := cpt11 + b stockTotal].
	self stockGC2: cpt11.
	'Stock des GC de LC2 apres ventes de la semaine: '
		, cpt11 asFloat printString printOn: Transcript.
	Transcript cr."
	self prixGC1: prix1.
	self prixGC2: prix2.
	self rationnementGC1: rationnement1.
	self rationnementGC2: rationnement2.	
	self rationnement: rationnement1 + rationnement2.
	"'Rationnement: ' , self rationnement asFloat printString
		printOn: Transcript.
	Transcript cr."
	"self
		prix: (prix1 * (15000 - rationnement1) + (prix2 * (15000 - rationnement2)))
				/ 30000 - self rationnement)."
	"'Rationnement total: ' , self rationnement asFloat printString
		printOn: Transcript.
	Transcript cr.
	'Prix moyen dans les LC: ' , self prix asFloat printString
		printOn: Transcript.
	Transcript cr."
	
"************************************************INDICATEURS DE RESULTATS*************************************************************"
	
	"Determination du stock residuel dans les LC"
	cpt11 := 0.
	GcLc1 do: [:b | cpt11 := cpt11 + b stockTotal].
	self stockGC1: cpt11.
	cpt11 := 0.
	GcLc2 do: [:b | cpt11 := cpt11 + b stockTotal].
	self stockGC2: cpt11.
	stockdesLC := self stockGC1 + self stockGC2.
	
	"Determination du stock residuel dans les LR"
	cpt7 := 0.
	GP1 do: [:b | cpt7 := cpt7 + b stockTotal].
	cpt30 := 0.
	GP2 do: [:b | cpt7 := cpt30 + b stockTotal].
	cpt31 := 0.
	GP3 do: [:b | cpt7 := cpt31 + b stockTotal].
	stockdesLR := cpt7 + cpt30 + cpt31.

	"Calcul des indicateurs de mauvaise allocation des ressources"
	rationnement > 0 ifTrue: [stockdesLR > 0 ifTrue: [self mauvaiseAllocationLRLC: self mauvaiseAllocationLCLC + 1]].
	rationnement > 0 ifTrue: [stockdesLC > 0 ifTrue: [self mauvaiseAllocationLCLC: self mauvaiseAllocationLCLC + 1]].
	

	self rationnementTotal: self rationnementTotal + rationnement.
	self rationnementTotal1: self rationnementTotal1 + rationnement1.
	self rationnementTotal2: self rationnementTotal2 + rationnement2.

	
	
	cpt :=0.
	self listePrixLC1 add: prix1. self listePrixLC1 do: [:a | cpt := cpt + a]. prixMoyenLC1 := cpt / 100. 
	cpt :=0.
	self listePrixLC1 do: [:a | cpt := cpt + ((a - prixMoyenLC1) * (a - prixMoyenLC1))]. variabilitePrixLC1 := (cpt / 100) sqrt.

	cpt :=0.
	self listePrixLC2 add: prix2. self listePrixLC2 do: [:a | cpt := cpt + a]. prixMoyenLC2 := cpt / 100. 
	cpt :=0.
	self listePrixLC2 do: [:a | cpt := cpt + ((a - prixMoyenLC2) * (a - prixMoyenLC2))]. variabilitePrixLC2 := (cpt / 100) sqrt.

	cpt :=0.
	self listePrix add: ((prix1 * (30000 - rationnement1) + (prix2 * (30000 - rationnement2))) / (60000 - self rationnement)). 
	self listePrix do: [:a | cpt := cpt + a]. self prixMoyen: cpt / 100. 
	"self variabilitePrix: ((variabilitePrixLC1 * (2400000 - rationnementTotal1) + (variabilitePrixLC2 * (900000 - rationnementTotal2))) / (3300000 - self rationnementTotal))."
self variabilitePrix: (variabilitePrixLC1 + variabilitePrixLC2) / 2.

	t = 100 ifTrue: [self prixMoyen asFloat printOn: Transcript. ' ; ' printString printOn: Transcript. prixMoyenLC1 asFloat printOn: Transcript. ' ; ' printString printOn: Transcript. prixMoyenLC2 asFloat printOn: Transcript. ' ; ' printString printOn: Transcript. self rationnementTotal asFloat printOn: Transcript. ' ; ' printString printOn: Transcript. self rationnementTotal1 asFloat printOn: Transcript.  ' ; ' printString printOn: Transcript. self rationnementTotal2 asFloat printOn: Transcript. ' ; ' printString printOn: Transcript. self mauvaiseAllocationLRLC asFloat printOn: Transcript.  ' ; ' printString printOn: Transcript. self mauvaiseAllocationLCLC asFloat printOn: Transcript.  ' ; ' printString printOn: Transcript. self variabilitePrix asFloat printOn: Transcript. ' ; ' printString printOn: Transcript. variabilitePrixLC1 asFloat printOn: Transcript. ' ; ' printString printOn: Transcript. variabilitePrixLC2 asFloat printOn: Transcript. Transcript cr].




	Transcript flush.
	self updateData: t.

"t = 20 ifTrue: [self export]"!

evoluatePlacesCm: t nFois: n
	"I- ACTUALISATION DU STOCK DES GP (APPROVISIONNEMENT EXOGENE)"

	| GcLc1 offreP2 p offreP cpt place e y yy yyy Dresiduelle cpt2 j Oresiduelle taux l offreLC offreLCTriee fonctionOffreLC GcLc2 o prixEtudies cpt7 prix1 rationnement1 prix2 rationnement2 w v toto GP1 GP2 GP3 g cpt20 offreLR offreLRTriee fonctionOffreLR tauxRationnement rationnement3 prix3 GcLr prixMoyenLC1 variabilitePrixLC1 prixMoyenLC2 variabilitePrixLC2 cpt11 stockdesLC cpt30 cpt31 stockdesLR file |
	cpt7 := 0.
	self theMarkets_Cells do: [:a | a aleaZone: (Cormas randomFrom: 1 to: 9)].
	self theMarkets_GPs do: 
			[:a | 
			a aleaIndividuel: (Cormas randomFrom: 1 to: 9).
			o := OrderedCollection new.
			o add: 250 - (10 * a patch aleaZone) - (10 * a aleaIndividuel).
			o add: 2400 + (160 * a patch aleaZone) + (160 * a aleaIndividuel).
			a achat: o.
			a lieu = #LR1 ifTrue: [cpt7 := cpt7 + a achat last].
			a receptionMarchandises].
	GP1 := self theMarkets_GPs select: [:z | z lieu = #LR1].
	GP2 := self theMarkets_GPs select: [:z | z lieu = #LR2].
	GP3 := self theMarkets_GPs select: [:z | z lieu = #LR3].
	"GP1 do: [:b | b achat isEmpty ifFalse: [cpt7 := cpt7 + b achat last]].
	'Approvisonnement des GP de LR1: ' , cpt7 asFloat printString
		printOn: Transcript.
	Transcript cr.
	cpt7 := 0.
	GP1 do: [:b | cpt7 := cpt7 + b stockTotal].
	'stock des GP de LR1 a la veille du jour de marche: '
		, cpt7 asFloat printString printOn: Transcript.
	Transcript cr."	

"II- PROCESSUS DE MARCHE ENTRE GP et GC"
	self theMarkets_GCs do: 
			[:a | 
			a choixLR.
			a leave.
			a moveTo: (self theMarkets_Cells at: a lrChoisie)].	

"****************************PROCESSUS DE MARCHE DANS LR1******************************************"	

"Determination de la D dans LR1"
	self theMarkets_GCs do: [:a | a qD: a stockSouhaite - (a stockTotal asFloat). a qD < 0 ifTrue: [a qD = 0]].
	place := self theMarkets_Cells detect: [:a | a nom = #LR1] ifNone: [nil].
	place isNil ifFalse: 
			[GcLr := self theMarkets_GCs select: [:b | b patch = place].
			GcLr isEmpty
				ifTrue: [place qD: 0]
				ifFalse: 
					[cpt20 := 0.
					GcLr do: [:a | cpt20 := cpt20 + a qD].
					place qD: cpt20]].
	place qD = 0 ifFalse: 
			["cpt7 := 0.
			GcLr do: [:b | cpt7 := cpt7 + b stockTotal].
			'stock des GC qui se sont rendus en LR1 au debut du jour de marche: '
				, cpt7 asFloat printString printOn: Transcript.
			Transcript cr."	


"Determination de l'O dans LR1"
			GP1 do: [:a | a supplyCm]. 
			offreLR := OrderedCollection new.
			offreLRTriee := OrderedCollection new.
			fonctionOffreLR := OrderedCollection new.
			GP1 do: 
					[:wx | 
					w := wx.
					w stock do: 
							[:vx | 
							v := vx.
							offreLR add: v]].
			offreLRTriee := offreLR asSortedCollection: [:a :b | a first < b first].
			prixEtudies := OrderedCollection new.
			offreLRTriee do: 
					[:couple | 
					p := couple first.
					(prixEtudies includes: p) ifFalse: 
							[offreP := offreLRTriee select: [:c2 | c2 first <= p].
							cpt := 0.
							offreP do: [:d | cpt := cpt + d last].
							offreP2 := OrderedCollection new.
							offreP2 add: p.
							offreP2 add: cpt.
							fonctionOffreLR add: offreP2.
							prixEtudies add: p]].	

"Determination du prix dans LR1 (et eventuellement du rationnement)"
			rationnement1 := 0.
			e := fonctionOffreLR detect: 
							[:gx | 
							g := gx.
							g last >= place qD]
						ifNone: [nil].
			e isNil
				ifFalse: [prix1 := e first]
				ifTrue: 
					[prix1 := fonctionOffreLR last first.
					rationnement1 := place qD - fonctionOffreLR last last].
			"'Prix de LR1: ' , prix1 printString printOn: Transcript.
			Transcript cr.
			'Rationnement de LR1: ' , rationnement1 asFloat printString printOn: Transcript.
			Transcript cr."	

"Determination des ventes des GP de LR1"
			GP1 do: [:u | u vente: OrderedCollection new].
			fonctionOffreLR last last <= place qD
				ifTrue: 
					[GP1 do: 
							[:a | 
							a fonctionOffre isEmpty ifFalse: 
									[a vente add: prix1.
									a vente add: a fonctionOffre last last]]]
				ifFalse: 
					[cpt := 0.
					GP1 do: 
							[:yx | 
							y := yx.
							yy := y fonctionOffre asSortedCollection: [:a :b | a first > b first].
							yyy := yy detect: [:z | z first < prix1] ifNone: [nil].
							yyy isNil ifFalse: 
									[cpt := cpt + yyy last.
									y vente add: prix1.
									y vente add: yyy last]].
					Dresiduelle := place qD - cpt.
					cpt2 := 0.
					GP1 do: 
							[:d | 
							j := d stock detect: [:jj | jj first = prix1] ifNone: [nil].
							j isNil ifFalse: [cpt2 := cpt2 + j last]].
					Oresiduelle := cpt2.
					Oresiduelle >= Dresiduelle ifTrue: 
							[taux := Dresiduelle / Oresiduelle. taux > 1 ifTrue: [self halt].
							GP1 do: 
									[:k | 
									l := k stock detect: [:kk | kk first = prix1] ifNone: [nil].
									l isNil ifFalse: 
											[k vente isEmpty
												ifTrue: 
													[k vente add: prix1.
													k vente add: l last * taux]
												ifFalse: 
													[toto := k vente last. 
													k vente: OrderedCollection new.
													k vente add: prix1.
													k vente add: toto + (l last * taux)]]]]].	

"Determination des achats des GC qui se sont rendus dans LR1"
			tauxRationnement := (place qD - rationnement1) / place qD.
			GcLr do: 
					[:a | 
					a achat: OrderedCollection new.
					a qD = 0 ifFalse: 
							[a achat add: prix1.
							a achat add: a qD * tauxRationnement]].
			"cpt7 := 0.
			GP1 do: [:a | a vente isEmpty ifFalse: [cpt7 := cpt7 + a vente last]].
			'ventes des GP de LR1: ' , cpt7 asFloat printString printOn: Transcript.
			Transcript cr.
			cpt7 := 0.
			GcLr do: [:a | a achat isEmpty ifFalse: [cpt7 := cpt7 + a achat last]].
			'achat des GC qui se sont rendus dans LR1: ' , cpt7 asFloat printString
				printOn: Transcript.
			Transcript cr."	


"Livraison des GP : actualisation des stocks des GP et des GC presents en LR1"
			GP1 do: [:a | a livraisonCm].
			GcLr do: [:a | a receptionMarchandises2].
			

			"cpt7 := 0.
			GP1 do: [:b | cpt7 := cpt7 + b stockTotal].
			'stock des GP de LR1 a la fin du jour de marche: '
				, cpt7 asFloat printString printOn: Transcript.
			Transcript cr.
			cpt7 := 0.
			GcLr do: [:b | cpt7 := cpt7 + b stockTotal].
			'stock des GC qui se sont rendus en LR1 a la fin du jour de marche: '
				, cpt7 asFloat printString printOn: Transcript.
			Transcript cr"].	

"****************************PROCESSUS DE MARCHE DANS LR2******************************************"	

"Determination de la D dans LR2"
	place := self theMarkets_Cells detect: [:a | a nom = #LR2] ifNone: [nil].
	place isNil ifFalse: 
			[GcLr := self theMarkets_GCs select: [:b | b patch = place].
			GcLr isEmpty
				ifTrue: [place qD: 0]
				ifFalse: 
					[cpt20 := 0.
					GcLr do: [:a | cpt20 := cpt20 + a qD].
					place qD: cpt20]].
	place qD = 0 ifFalse: 
			["cpt7 := 0.
			GcLr do: [:b | cpt7 := cpt7 + b stockTotal].
			'stock des GC qui se sont rendus en LR2 au debut du jour de marche: '
				, cpt7 asFloat printString printOn: Transcript.
			Transcript cr."	

"Determination de l'O dans LR2"
			GP2 do: [:a | a supplyCm].
			offreLR := OrderedCollection new.
			offreLRTriee := OrderedCollection new.
			fonctionOffreLR := OrderedCollection new.
			GP2 do: 
					[:wx | 
					w := wx.
					w stock do: 
							[:vx | 
							v := vx.
							offreLR add: v]].
			offreLRTriee := offreLR asSortedCollection: [:a :b | a first < b first].
			prixEtudies := OrderedCollection new.
			offreLRTriee do: 
					[:couple | 
					p := couple first.
					(prixEtudies includes: p) ifFalse: 
							[offreP := offreLRTriee select: [:c2 | c2 first <= p].
							cpt := 0.
							offreP do: [:d | cpt := cpt + d last].
							offreP2 := OrderedCollection new.
							offreP2 add: p.
							offreP2 add: cpt.
							fonctionOffreLR add: offreP2.
							prixEtudies add: p]].	

"Determination du prix dans LR2 (et eventuellement du rationnement)"
			rationnement2 := 0.
			e := fonctionOffreLR detect: 
							[:gx | 
							g := gx.
							g last >= place qD]
						ifNone: [nil].
			e isNil
				ifFalse: [prix2 := e first]
				ifTrue: 
					[prix2 := fonctionOffreLR last first.
					rationnement2 := place qD - fonctionOffreLR last last].
			"'Prix de LR2: ' , prix2 printString printOn: Transcript.
			Transcript cr.
			'Rationnement de LR2: ' , rationnement2 asFloat printString printOn: Transcript.
			Transcript cr."	

"Determination des ventes des GP de LR2"
			GP2 do: [:u | u vente: OrderedCollection new].
			fonctionOffreLR last last <= place qD
				ifTrue: 
					[GP2 do: 
							[:a | 
							a fonctionOffre isEmpty ifFalse: 
									[a vente add: prix2.
									a vente add: a fonctionOffre last last]]]
				ifFalse: 
					[cpt := 0.
					GP2 do: 
							[:yx | 
							y := yx.
							yy := y fonctionOffre asSortedCollection: [:a :b | a first > b first].
							yyy := yy detect: [:z | z first < prix2] ifNone: [nil].
							yyy isNil ifFalse: 
									[cpt := cpt + yyy last.
									y vente add: prix2.
									y vente add: yyy last]].
					Dresiduelle := place qD - cpt.
					cpt2 := 0.
					GP2 do: 
							[:d | 
							j := d stock detect: [:jj | jj first = prix2] ifNone: [nil].
							j isNil ifFalse: [cpt2 := cpt2 + j last]].
					Oresiduelle := cpt2.
					Oresiduelle >= Dresiduelle ifTrue: 
							[taux := Dresiduelle / Oresiduelle. taux > 1 ifTrue: [self halt].
							GP2 do: 
									[:k | 
									l := k stock detect: [:kk | kk first = prix2] ifNone: [nil].
									l isNil ifFalse: 
											[k vente isEmpty
												ifTrue: 
													[k vente add: prix2.
													k vente add: l last * taux]
												ifFalse: 
													[toto := k vente last.
													k vente: OrderedCollection new.
													k vente add: prix2.
													k vente add: toto + (l last * taux)]]]]].	


"Determination des achats des GC qui se sont rendus dans LR2"
			tauxRationnement := (place qD - rationnement2) / place qD.
			GcLr do: 
					[:a | 
					a achat: OrderedCollection new.
					a qD = 0 ifFalse: 
							[a achat add: prix2.
							a achat add: a qD * tauxRationnement]].
			"cpt7 := 0.
			GP2 do: [:a | a vente isEmpty ifFalse: [cpt7 := cpt7 + a vente last]].
			'ventes des GP de LR2: ' , cpt7 asFloat printString printOn: Transcript.
			Transcript cr.
			cpt7 := 0.
			GcLr do: [:a | a achat isEmpty ifFalse: [cpt7 := cpt7 + a achat last]].
			'achat des GC qui se sont rendus dans LR2: ' , cpt7 asFloat printString
				printOn: Transcript.
			Transcript cr."	

"Livraison des GP : actualisation des stocks des GP et des GC presents en LR2"
			GP2 do: [:a | a livraisonCm].
			GcLr do: [:a | a receptionMarchandises2].
			"cpt7 := 0.
			GP2 do: [:b | cpt7 := cpt7 + b stockTotal].
			'stock des GP de LR2 a la fin du jour de marche: '
				, cpt7 asFloat printString printOn: Transcript.
			Transcript cr.
			cpt7 := 0.
			GcLr do: [:b | cpt7 := cpt7 + b stockTotal].
			'stock des GC qui se sont rendus en LR2 a la fin du jour de marche: '
				, cpt7 asFloat printString printOn: Transcript.
			Transcript cr"].

"****************************PROCESSUS DE MARCHE DANS LR3******************************************"	

"Determination de la D dans LR3"
	self theMarkets_GCs do: [:a | a qD: a stockSouhaite - a stockTotal].
	place := self theMarkets_Cells detect: [:a | a nom = #LR3] ifNone: [nil].
	place isNil ifFalse: 
			[GcLr := self theMarkets_GCs select: [:b | b patch = place].
			GcLr isEmpty
				ifTrue: [place qD: 0]
				ifFalse: 
					[cpt20 := 0.
					GcLr do: [:a | cpt20 := cpt20 + a qD].
					place qD: cpt20]].
	place qD = 0 ifFalse: 
			["cpt7 := 0.
			GcLr do: [:b | cpt7 := cpt7 + b stockTotal].
			'stock des GC qui se sont rendus en LR3 au debut du jour de marche: '
				, cpt7 asFloat printString printOn: Transcript.
			Transcript cr."	


"Determination de l'O dans LR3"
			GP3 do: [:a | a supplyCm].
			offreLR := OrderedCollection new.
			offreLRTriee := OrderedCollection new.
			fonctionOffreLR := OrderedCollection new.
			GP3 do: 
					[:wx | 
					w := wx.
					w stock do: 
							[:vx | 
							v := vx.
							offreLR add: v]].
			offreLRTriee := offreLR asSortedCollection: [:a :b | a first < b first].
			prixEtudies := OrderedCollection new.
			offreLRTriee do: 
					[:couple | 
					p := couple first.
					(prixEtudies includes: p) ifFalse: 
							[offreP := offreLRTriee select: [:c2 | c2 first <= p].
							cpt := 0.
							offreP do: [:d | cpt := cpt + d last].
							offreP2 := OrderedCollection new.
							offreP2 add: p.
							offreP2 add: cpt.
							fonctionOffreLR add: offreP2.
							prixEtudies add: p]].	

"Determination du prix dans LR3 (et eventuellement du rationnement)"
			rationnement3 := 0.
			e := fonctionOffreLR detect: 
							[:gx | 
							g := gx.
							g last >= place qD]
						ifNone: [nil].
			e isNil
				ifFalse: [prix3 := e first]
				ifTrue: 
					[prix3 := fonctionOffreLR last first.
					rationnement3 := place qD - fonctionOffreLR last last].
			"'Prix de LR3: ' , prix3 printString printOn: Transcript.
			Transcript cr.
			'Rationnement de LR3: ' , rationnement3 asFloat printString
				printOn: Transcript.
			Transcript cr."	

"Determination des ventes des GP de LR3"
			GP3 do: [:u | u vente: OrderedCollection new].
			fonctionOffreLR last last <= place qD
				ifTrue: 
					[GP3 do: 
							[:a | 
							a fonctionOffre isEmpty ifFalse: 
									[a vente add: prix3.
									a vente add: a fonctionOffre last last]]]
				ifFalse: 
					[cpt := 0.
					GP3 do: 
							[:yx | 
							y := yx.
							yy := y fonctionOffre asSortedCollection: [:a :b | a first > b first].
							yyy := yy detect: [:z | z first < prix3] ifNone: [nil].
							yyy isNil ifFalse: 
									[cpt := cpt + yyy last.
									y vente add: prix3.
									y vente add: yyy last]].
					Dresiduelle := place qD - cpt.
					cpt2 := 0.
					GP3 do: 
							[:d | 
							j := d stock detect: [:jj | jj first = prix3] ifNone: [nil].
							j isNil ifFalse: [cpt2 := cpt2 + j last]].
					Oresiduelle := cpt2.
					Oresiduelle >= Dresiduelle ifTrue: 
							[taux := Dresiduelle / Oresiduelle. taux > 1 ifTrue: [self halt].
							GP3 do: 
									[:k | 
									l := k stock detect: [:kk | kk first = prix3] ifNone: [nil].
									l isNil ifFalse: 
											[k vente isEmpty
												ifTrue: 
													[k vente add: prix3.
													k vente add: l last * taux]
												ifFalse: 
													[toto := k vente last.
													k vente: OrderedCollection new.
													k vente add: prix3.
													k vente add: toto + (l last * taux)]]]]].	

"Determination des achats des GC qui se sont rendus dans LR3"
			tauxRationnement := (place qD - rationnement3) / place qD.
			GcLr do: 
					[:a | 
					a achat: OrderedCollection new.
					a qD = 0 ifFalse: 
							[a achat add: prix3.
							a achat add: a qD * tauxRationnement]].
			"cpt7 := 0.
			GP3 do: [:a | a vente isEmpty ifFalse: [cpt7 := cpt7 + a vente last]].
			'ventes des GP de LR3: ' , cpt7 asFloat printString printOn: Transcript.
			Transcript cr.
			cpt7 := 0.
			GcLr do: [:a | a achat isEmpty ifFalse: [cpt7 := cpt7 + a achat last]].
			'achat des GC qui se sont rendus dans LR3: ' , cpt7 asFloat printString
				printOn: Transcript.
			Transcript cr."	

"Livraison des GP : actualisation des stocks des GP et des GC presents en LR3"
			GP3 do: [:a | a livraisonCm].
			GcLr do: [:a | a receptionMarchandises2].
			"cpt7 := 0.
			GP3 do: [:b | cpt7 := cpt7 + b stockTotal].
			'stock des GP de LR3 a la fin du jour de marche: '
				, cpt7 asFloat printString printOn: Transcript.
			Transcript cr.
			cpt7 := 0.
			GcLr do: [:b | cpt7 := cpt7 + b stockTotal].
			'stock des GC qui se sont rendus en LR3 a la fin du jour de marche: '
				, cpt7 asFloat printString printOn: Transcript.
			Transcript cr"].

"III- PROCESSUS DE MARCHE EN AVAL DES GC (DANS LES LC)"	

"Determination des offres individuelles des GP"
	self theMarkets_GCs do: [:a | a supplyCm].	

"Determination de la fonction d'offre de LC1"
	GcLc1 := self theMarkets_GCs select: [:z | z lieu = #LC1].
	offreLC := OrderedCollection new.
	offreLCTriee := OrderedCollection new.
	fonctionOffreLC := OrderedCollection new.
	GcLc1 do: 
			[:wx | 
			w := wx.
			w stock do: 
					[:vx | 
					v := vx.
					offreLC add: v]].
	offreLCTriee := offreLC asSortedCollection: [:a :b | a first < b first].
	prixEtudies := OrderedCollection new.
	offreLCTriee do: 
			[:couple | 
			p := couple first.
			(prixEtudies includes: p) ifFalse: 
					[offreP := offreLCTriee select: [:c2 | c2 first <= p].
					cpt := 0.
					offreP do: [:d | cpt := cpt + d last].
					offreP2 := OrderedCollection new.
					offreP2 add: p.
					offreP2 add: cpt.
					fonctionOffreLC add: offreP2.
					prixEtudies add: p]].	

"Determination du prix d'equilibre de LC1 (et eventuellement du rationnement) en utilisant une fonction 
	de D exogene"
	rationnement1 := 0.
	place := self theMarkets_Cells detect: [:f | f nom = #LC1].
	e := fonctionOffreLC detect: 
					[:gx | 
					g := gx.
					g last >= place qD]
				ifNone: [nil].
	e isNil
		ifFalse: [prix1 := e first]
		ifTrue: 
			[prix1 := fonctionOffreLC last first.
			rationnement1 := place qD - fonctionOffreLC last last].	

"Determination des commandes des GC de LC1 (collection vente) a partir du prix d''equilibre"
	GcLc1 do: [:u | u vente: OrderedCollection new].
	fonctionOffreLC last last <= place qD
		ifTrue: 
			[GcLc1 do: 
					[:a | 
					a fonctionOffre isEmpty ifFalse: 
							[a vente add: prix1.
							a vente add: a fonctionOffre last last]]]
		ifFalse: 
			[cpt := 0.
			GcLc1 do: 
					[:yx | 
					y := yx.
					yy := y fonctionOffre asSortedCollection: [:a :b | a first > b first].
					yyy := yy detect: [:z | z first < prix1] ifNone: [nil].
					yyy isNil ifFalse: 
							[cpt := cpt + yyy last.
							y vente add: prix1.
							y vente add: yyy last]].
			Dresiduelle := place qD - cpt.
			cpt2 := 0.
			GcLc1 do: 
					[:d | 
					j := d stock detect: [:jj | jj first = prix1] ifNone: [nil].
					j isNil ifFalse: [cpt2 := cpt2 + j last]].
			Oresiduelle := cpt2.
			Oresiduelle >= Dresiduelle ifTrue: 
					[taux := Dresiduelle / Oresiduelle. taux > 1 ifTrue: [self halt].
					GcLc1 do: 
							[:k | 
							l := k stock detect: [:kk | kk first = prix1] ifNone: [nil].
							l isNil ifFalse: 
									[k vente isEmpty
										ifTrue: 
											[k vente add: prix1.
											k vente add: l last * taux]
										ifFalse: 
											[toto := k vente last.
											k vente: OrderedCollection new.
											k vente add: prix1.
											k vente add: toto + (l last * taux)]]]]].	

"Determination de la fonction d'offre de LC2"
	GcLc2 := self theMarkets_GCs select: [:z | z lieu = #LC2].
	offreLC := OrderedCollection new.
	offreLCTriee := OrderedCollection new.
	fonctionOffreLC := OrderedCollection new.
	GcLc2 do: 
			[:wx | 
			w := wx.
			w stock do: 
					[:vx | 
					v := vx.
					offreLC add: v]].
	offreLCTriee := offreLC asSortedCollection: [:a :b | a first < b first].
	prixEtudies := OrderedCollection new.
	offreLCTriee do: 
			[:couple | 
			p := couple first.
			(prixEtudies includes: p) ifFalse: 
					[offreP := offreLCTriee select: [:c2 | c2 first <= p].
					cpt := 0.
					offreP do: [:d | cpt := cpt + d last].
					offreP2 := OrderedCollection new.
					offreP2 add: p.
					offreP2 add: cpt.
					fonctionOffreLC add: offreP2.
					prixEtudies add: p]].	

"Determination du prix d'equilibre de LC2 (et eventuellement du rationnement)"
	rationnement2 := 0.
	place := self theMarkets_Cells detect: [:f | f nom = #LC2].
	e := fonctionOffreLC detect: 
					[:gx | 
					g := gx.
					g last >= place qD]
				ifNone: [nil].
	e isNil
		ifFalse: [prix2 := e first]
		ifTrue: 
			[prix2 := fonctionOffreLC last first.
			rationnement2 := place qD - fonctionOffreLC last last].	

"Determination des commandes des GC de LC2 (collection vente) a partir du prix d''equilibre"
	GcLc2 do: [:u | u vente: OrderedCollection new].
	fonctionOffreLC last last <= place qD
		ifTrue: 
			[GcLc2 do: 
					[:a | 
					a fonctionOffre isEmpty ifFalse: 
							[a vente add: prix2.
							a vente add: a fonctionOffre last last]]]
		ifFalse: 
			[cpt := 0.
			GcLc2 do: 
					[:yx | 
					y := yx.
					yy := y fonctionOffre asSortedCollection: [:a :b | a first > b first].
					yyy := yy detect: [:z | z first < prix2] ifNone: [nil].
					yyy isNil ifFalse: 
							[cpt := cpt + yyy last.
							y vente add: prix2.
							y vente add: yyy last]].
			Dresiduelle := place qD - cpt.
			cpt2 := 0.
			GcLc2 do: 
					[:d | 
					j := d stock detect: [:jj | jj first = prix2] ifNone: [nil].
					j isNil ifFalse: [cpt2 := cpt2 + j last]].
			Oresiduelle := cpt2.
			Oresiduelle >= Dresiduelle ifTrue: 
					[taux := Dresiduelle / Oresiduelle. taux > 1 ifTrue: [self halt].
					GcLc2 do: 
							[:k | 
							l := k stock detect: [:kk | kk first = prix2] ifNone: [nil].
							l isNil ifFalse: 
									[k vente isEmpty
										ifTrue: 
											[k vente add: prix2.
											k vente add: l last * taux]
										ifFalse: 
											[toto := k vente last.
											k vente: OrderedCollection new.
											k vente add: prix2.
											k vente add: toto + (l last * taux)]]]]].
	"cpt15 := 0.
	GcLc1 do: [:a | a vente isEmpty ifFalse: [cpt15 := cpt15 + a vente last]].
	'Ventes des GC de LC1: ' , cpt15 asFloat printString printOn: Transcript.
	Transcript cr.
	cpt15 := 0.
	GcLc2 do: [:a | a vente isEmpty ifFalse: [cpt15 := cpt15 + a vente last]].
	'Ventes des GC de LC2: ' , cpt15 asFloat printString printOn: Transcript.
	Transcript cr.
	cpt15 := 0.
	self theMarkets_GCs
		do: [:a | a vente isEmpty ifFalse: [cpt15 := cpt15 + a vente last]].
	'Ventes des GC: ' , cpt15 asFloat printString printOn: Transcript.
	Transcript cr."	

"Livraison des GC ie actualisation de leur stock"
	self theMarkets_GCs do: [:a | a livraisonCm].	


"Sorties graphiques et ecran"
	"'Prix de LC1: ' , prix1 asFloat printString printOn: Transcript.
	Transcript cr.
	'Rationnement de LC1: ' , rationnement1 asFloat printString
		printOn: Transcript.
	Transcript cr.
	cpt11 := 0.
	GcLc1 do: [:b | cpt11 := cpt11 + b stockTotal].
	self stockGC1: cpt11.
	'Stock des GC de LC1 apres ventes de la semaine: '
		, cpt11 asFloat printString printOn: Transcript.
	Transcript cr.
	'Prix de LC2: ' , prix2 asFloat printString printOn: Transcript.
	Transcript cr.
	'Rationnement de LC2: ' , rationnement2 asFloat printString
		printOn: Transcript.
	Transcript cr.
	cpt11 := 0.
	GcLc2 do: [:b | cpt11 := cpt11 + b stockTotal].
	self stockGC2: cpt11.
	'Stock des GC de LC2 apres ventes de la semaine: '
		, cpt11 asFloat printString printOn: Transcript.
	Transcript cr."
	self prixGC1: prix1.
	self prixGC2: prix2.
	self rationnementGC1: rationnement1.
	self rationnementGC2: rationnement2.	
	self rationnement: rationnement1 + rationnement2.
	"'Rationnement: ' , self rationnement asFloat printString
		printOn: Transcript.
	Transcript cr."
	"self
		prix: (prix1 * (15000 - rationnement1) + (prix2 * (15000 - rationnement2)))
				/ 30000 - self rationnement)."
	"'Rationnement total: ' , self rationnement asFloat printString
		printOn: Transcript.
	Transcript cr.
	'Prix moyen dans les LC: ' , self prix asFloat printString
		printOn: Transcript.
	Transcript cr."
	
"************************************************INDICATEURS DE RESULTATS*************************************************************"
	
	"Determination du stock residuel dans les LC"
	cpt11 := 0.
	GcLc1 do: [:b | cpt11 := cpt11 + b stockTotal].
	self stockGC1: cpt11.
	cpt11 := 0.
	GcLc2 do: [:b | cpt11 := cpt11 + b stockTotal].
	self stockGC2: cpt11.
	stockdesLC := self stockGC1 + self stockGC2.
	
	"Determination du stock residuel dans les LR"
	cpt7 := 0.
	GP1 do: [:b | cpt7 := cpt7 + b stockTotal].
	cpt30 := 0.
	GP2 do: [:b | cpt7 := cpt30 + b stockTotal].
	cpt31 := 0.
	GP3 do: [:b | cpt7 := cpt31 + b stockTotal].
	stockdesLR := cpt7 + cpt30 + cpt31.

	"Calcul des indicateurs de mauvaise allocation des ressources"
	rationnement > 0 ifTrue: [stockdesLR > 0 ifTrue: [self mauvaiseAllocationLRLC: self mauvaiseAllocationLCLC + 1]].
	rationnement > 0 ifTrue: [stockdesLC > 0 ifTrue: [self mauvaiseAllocationLCLC: self mauvaiseAllocationLCLC + 1]].
	

	self rationnementTotal: self rationnementTotal + rationnement.
	self rationnementTotal1: self rationnementTotal1 + rationnement1.
	self rationnementTotal2: self rationnementTotal2 + rationnement2.

	
	
	cpt :=0.
	self listePrixLC1 add: prix1. self listePrixLC1 do: [:a | cpt := cpt + a]. prixMoyenLC1 := cpt / 100. 
	cpt :=0.
	self listePrixLC1 do: [:a | cpt := cpt + ((a - prixMoyenLC1) * (a - prixMoyenLC1))]. variabilitePrixLC1 := (cpt / 100) sqrt.

	cpt :=0.
	self listePrixLC2 add: prix2. self listePrixLC2 do: [:a | cpt := cpt + a]. prixMoyenLC2 := cpt / 100. 
	cpt :=0.
	self listePrixLC2 do: [:a | cpt := cpt + ((a - prixMoyenLC2) * (a - prixMoyenLC2))]. variabilitePrixLC2 := (cpt / 100) sqrt.

	cpt :=0.
	self listePrix add: ((prix1 * (30000 - rationnement1) + (prix2 * (30000 - rationnement2))) / (60000 - self rationnement)). 
	self listePrix do: [:a | cpt := cpt + a]. self prixMoyen: cpt / 100. 
	"self variabilitePrix: ((variabilitePrixLC1 * (2400000 - rationnementTotal1) + (variabilitePrixLC2 * (900000 - rationnementTotal2))) / (3300000 - self rationnementTotal))."
self variabilitePrix: (variabilitePrixLC1 + variabilitePrixLC2) / 2.


t = 100 ifTrue: [ 	file := ((Cormas dataPath: self class name)
				, 'frank.txt') asFilename appendStream.	 file nextPutAll: self prixMoyen asFloat printString,';' . file nextPutAll: prixMoyenLC1 asFloat printString,';' . file nextPutAll: prixMoyenLC2 asFloat printString,';' . file nextPutAll: self rationnementTotal asFloat printString,';' . file nextPutAll: self rationnementTotal1 asFloat printString,';' . file nextPutAll: self rationnementTotal2 asFloat printString,';' . file nextPutAll: self mauvaiseAllocationLRLC asFloat printString,';' . file nextPutAll: self mauvaiseAllocationLCLC asFloat printString,';' . file nextPutAll: self variabilitePrix asFloat printString,';' . file nextPutAll: variabilitePrixLC1 asFloat printString,';' . file nextPutAll: variabilitePrixLC2 asFloat printString.
	file nextPutAll: '\' withCRs. file close].

	"t = 100 ifTrue: [self prixMoyen asFloat printOn: Transcript. ' ; ' printString printOn: Transcript. prixMoyenLC1 asFloat printOn: Transcript. ' ; ' printString printOn: Transcript. prixMoyenLC2 asFloat printOn: Transcript. ' ; ' printString printOn: Transcript. self rationnementTotal asFloat printOn: Transcript. ' ; ' printString printOn: Transcript. self rationnementTotal1 asFloat printOn: Transcript.  ' ; ' printString printOn: Transcript. self rationnementTotal2 asFloat printOn: Transcript. ' ; ' printString printOn: Transcript. self mauvaiseAllocationLRLC asFloat printOn: Transcript.  ' ; ' printString printOn: Transcript. self mauvaiseAllocationLCLC asFloat printOn: Transcript.  ' ; ' printString printOn: Transcript. self variabilitePrix asFloat printOn: Transcript. ' ; ' printString printOn: Transcript. variabilitePrixLC1 asFloat printOn: Transcript. ' ; ' printString printOn: Transcript. variabilitePrixLC2 asFloat printOn: Transcript. Transcript cr]."




	Transcript flush.
	self updateData: t.

"t = 20 ifTrue: [self export]"!

evoluateReseauxCM: t
"To be completed"

	
"I- Le controleur actualise le stock des GP par un approvisionnement exogene. A terme, on pourrait introduire une demande externe exogene, afin d'introduire un alea non plus seulement sur le flux d'approvisionnement mais aussi sur le stock lui meme"
| GcLc1 offreLC1 offreLC1Triee fonctionOffreLC1 offreP2 p offreP cpt place e prix rationnement venteGC venteGCTriee |
	self theMarkets_Cells do: [:a | a aleaZone: (Cormas randomFrom: 1 to: 9)].
self theMarkets_GCs do: [:a | a aleaIndividuel: (Cormas randomFrom: 1 to: 5). a achat: (1400 + (100 * a patch aleaZone) + (100 * a aleaIndividuel))].


"II- Processus de marche entre GP et GC"
	self theMarkets_GCs do: [:a | a sendBid. a listeGP do: [:b | b sendOffer].
	a sendContract. a listeGP do: [:c | c livraisonMarchandises]. a receptionMarchandises].

	

"III- Processus de marche en aval des GC (dans les LC)"	
	self theMarkets_GCs do: [:a | a supplyLC].

"Processus de marche dans LC1"

"1. Creation de la fonction d'O de LC1"
GcLc1 := self theMarkets_GCs select: [:z | z lieu = #LC1].
offreLC1  := OrderedCollection new.
offreLC1Triee  := OrderedCollection new. 
fonctionOffreLC1 := OrderedCollection new.
offreP2 := OrderedCollection new.
GcLc1 do: [:w | w fonctionOffre do: [: v | offreLC1 add: v]].
offreLC1Triee := offreLC1 asSortedCollection: [:a :b | a first < b first].
	 offreLC1Triee do: [p := offreLC1Triee first first. 
offreP :=  offreLC1Triee select: [:c2 | c2 first = p]. cpt := 0. offreP do: [:d | cpt := cpt + d last]. offreP2 add: p. offreP2 add: p. fonctionOffreLC1 add: offreP2.  offreLC1Triee  removeAll: offreP].

"2. Le controleur calcule le prix d'equilibre de chaque localite en utilisant une fonction de D exogene. En cas de deficit d O les courbes en se coupent pas. Ici on a fait le choix de prendre comme prix le prix permettant l O maximale. Il serait aussi possible de considerant un prix plus eleve en faisant l hypothese que les GC augmentent leur marge d'un montant fixe ou proportionnel au deficit (un traitement ex post a partir des sorties est aussi possible, ce qui evite d'avoir a faire de nombreux scenarios). De toutes façons, il faut aussi prendre en compte l'impact direct du deficit sur les consommateurs via le rationnement. " 

place := self theMarkets_GCs detect: [:f | f nom = #LC1].
e := fonctionOffreLC1 detect: [:g | g last = place qD]. e isNil ifFalse: [prix := e first] ifTrue: [prix := fonctionOffreLC1 last first. rationnement := place qD - fonctionOffreLC1 last last].
self theMarkets_GCs do: [:h | "Probleme de determination de la Q dans les cas ou les Gc peuvent offrir plusieurs Q pour un volume de prix donne. Faire au prorata. Donc calcul de la Qmax offerte par chacun. Comparaison avec la qD. Chacun vend au prorata de sa Qmax. Mais quid si ca ne tombe pas sur des valeurs entieres. Autre option : selectionner au hasard des Gc qui vendent tout ce qu ils offrent pour le prix d eqbre" venteGC := OrderedCollection new. venteGC := h fonctionOffre select: [:u | u first = prix]. venteGCTriee := venteGC asSortedCollection: [:a :b | a first < b first].h vente: venteGCTriee].


"3. Actualiser le stock du GC a partir de sa collection vente"
self theMarkets_GCs do: [:a | a livraisonMarchandises].


		self updateData: t.!

evoluateReseauxCm: t 
	"I- ACTUALISATION DU STOCK DES GP (APPROVISIONNEMENT EXOGENE)"

	| GcLc1 offreP2 p offreP cpt place e y yy yyy Dresiduelle cpt2 j Oresiduelle taux l offreLC offreLCTriee fonctionOffreLC GcLc2 o prixEtudies cpt7 cpt8 cpt10 cpt11 prix1 rationnement1 prix2 rationnement2 w v toto GP1 GP2 GP3 copieGC g gc prixMoyenLC1 variabilitePrixLC1 prixMoyenLC2 variabilitePrixLC2 stockdesLC cpt30 cpt31 stockdesLR |
	cpt8 := 0.
	self theMarkets_Cells do: [:a | a aleaZone: (Cormas randomFrom: 1 to: 9)].
	self theMarkets_GPs do: 
			[:a | 
			a aleaIndividuel: (Cormas randomFrom: 1 to: 9).
			o := OrderedCollection new.
			o add: 250 - (10 * a patch aleaZone) - (10 * a aleaIndividuel).
			o add: 2400 + (160 * a patch aleaZone) + (160 * a aleaIndividuel).
			a achat: o.
			cpt8 := cpt8 + a achat last.
			a receptionMarchandises].	"'Approvisonnement des GP: ' , cpt8 asFloat printString printOn: Transcript.
	Transcript cr.
	cpt6 := 0.
	self theMarkets_GPs do: [:b | cpt6 := cpt6 + b stockTotal].
	self stockGP: cpt6.
	'Stock des GP avant vente aux GC: ' , self stockGP asFloat printString printOn: Transcript.
	Transcript cr.
	cpt11 := 0.
	self theMarkets_GCs do: [:b | cpt11 := cpt11 + b stockTotal].
	self stockGC: cpt11.
	'stock des GC avant achat aux GP: ' , self stockGC asFloat printString printOn: Transcript. 	Transcript cr."
	GP1 := self theMarkets_GPs select: [:z | z lieu = #LR1].
	GP2 := self theMarkets_GPs select: [:z | z lieu = #LR2].
	GP3 := self theMarkets_GPs select: [:z | z lieu = #LR3].
	cpt11 := 0.
	GP1 do: [:b | cpt11 := cpt11 + b stockTotal].
	self stockGP1: cpt11.
	cpt11 := 0.
	GP2 do: [:b | cpt11 := cpt11 + b stockTotal].
	self stockGP2: cpt11.
	cpt11 := 0.
	GP3 do: [:b | cpt11 := cpt11 + b stockTotal].
	self stockGP3: cpt11.	"II- PROCESSUS DE MARCHE ENTRE GP et GC"
	cpt7 := 0.
	cpt10 := 0.
	copieGC := OrderedCollection new.
	copieGC addAll: self theMarkets_GCs.
	1 to: 30
		do: 
			[:i | 
			g := Cormas randomFrom: 1 to: 31 - i.
			gc := copieGC at: g.
			gc sendBid.
			gc listeGP do: [:b | b sendOfferCm].
			gc sendContract.
			gc listeGP do: [:b | b sendOfferCm].
			gc sendContract2.
			cpt10 := cpt10 + gc achatTotal.
			gc listeGP do: 
					[:c | 
					c lectureCommandes.
					c vente isEmpty ifFalse: [cpt7 := cpt7 + c vente last].
					c livraisonCm].
			gc receptionMarchandises.
			copieGC remove: gc].	"ventesGP := cpt7.
	'ventes des GP: ' , ventesGP asFloat printString printOn: Transcript.
	Transcript cr.
	cpt9 := 0.
	self theMarkets_GPs do: [:b | cpt9 := cpt9 + b stockTotal].
	stockGPbis := cpt9.
	'stock des GP apres vente aux GC: ' , stockGPbis asFloat printString printOn: Transcript.
	Transcript cr.
	achatGC := cpt10.
	'achat des GC: ' , achatGC asFloat printString printOn: Transcript.
	Transcript cr.
	cpt5 := 0.
	self theMarkets_GCs do: [:b | cpt5 := cpt5 + b stockTotal].
	self stockGC: cpt5.
	'stock des GC apres achat aux GP: ' , self stockGC asFloat printString printOn: Transcript.
	Transcript cr."	"III- PROCESSUS DE MARCHE EN AVAL DES GC (DANS LES LC)"	"Determination des offres individuelles des GP"
	self theMarkets_GCs do: [:a | a supplyCm].	"Determination de la fonction d'offre de LC1"
	GcLc1 := self theMarkets_GCs select: [:z | z lieu = #LC1].
	offreLC := OrderedCollection new.
	offreLCTriee := OrderedCollection new.
	fonctionOffreLC := OrderedCollection new.
	GcLc1 do: 
			[:wx | 
			w := wx.
			w stock do: 
					[:vx | 
					v := vx.
					offreLC add: v]].
	offreLCTriee := offreLC asSortedCollection: [:a :b | a first < b first].
	prixEtudies := OrderedCollection new.
	offreLCTriee do: 
			[:couple | 
			p := couple first.
			(prixEtudies includes: p) ifFalse: 
					[offreP := offreLCTriee select: [:c2 | c2 first <= p].
					cpt := 0.
					offreP do: [:d | cpt := cpt + d last].
					offreP2 := OrderedCollection new.
					offreP2 add: p.
					offreP2 add: cpt.
					fonctionOffreLC add: offreP2.
					prixEtudies add: p]].	"Determination du prix d'equilibre de LC1 (et eventuellement du rationnement) en utilisant une fonction 
	de D exogene"
	rationnement1 := 0.
	place := self theMarkets_Cells detect: [:f | f nom = #LC1].
	e := fonctionOffreLC detect: 
					[:gx | 
					g := gx.
					g last >= place qD]
				ifNone: [nil].
	e isNil
		ifFalse: [prix1 := e first]
		ifTrue: 
			[prix1 := fonctionOffreLC last first.
			rationnement1 := place qD - fonctionOffreLC last last].	"'Prix de LC1: ' , prix1 asFloat printString printOn: Transcript. Transcript cr.
	'Rationnement de LC1: ' , rationnement1 asFloat printString printOn: Transcript.
	Transcript cr."	"Determination des commandes des GC de LC1 (collection vente) a partir du prix d''equilibre"
	GcLc1 do: [:u | u vente: OrderedCollection new].
	fonctionOffreLC last last <= place qD
		ifTrue: 
			[GcLc1 do: 
					[:a | 
					a fonctionOffre isEmpty ifFalse: 
							[a vente add: prix1.
							a vente add: a fonctionOffre last last]]]
		ifFalse: 
			[cpt := 0.
			GcLc1 do: 
					[:yx | 
					y := yx.
					yy := y fonctionOffre asSortedCollection: [:a :b | a first > b first].
					yyy := yy detect: [:z | z first < prix1] ifNone: [nil].
					yyy isNil ifFalse: 
							[cpt := cpt + yyy last.
							y vente add: prix1.
							y vente add: yyy last]].
			Dresiduelle := place qD - cpt.
			cpt2 := 0.
			GcLc1 do: 
					[:d | 
					j := d stock detect: [:jj | jj first = prix1] ifNone: [nil].
					j isNil ifFalse: [cpt2 := cpt2 + j last]].
			Oresiduelle := cpt2.
			Oresiduelle >= Dresiduelle ifTrue: 
					[taux := Dresiduelle / Oresiduelle.
					GcLc1 do: 
							[:k | 
							l := k stock detect: [:kk | kk first = prix1] ifNone: [nil].
							l isNil ifFalse: 
									[k vente isEmpty
										ifTrue: 
											[k vente add: prix1.
											k vente add: l last * taux]
										ifFalse: 
											[toto := k vente last.
											k vente: OrderedCollection new.
											k vente add: prix1.
											k vente add: toto + (l last * taux)]]]]].	"Determination de la fonction d'offre de LC2"
	GcLc2 := self theMarkets_GCs select: [:z | z lieu = #LC2].
	offreLC := OrderedCollection new.
	offreLCTriee := OrderedCollection new.
	fonctionOffreLC := OrderedCollection new.
	GcLc2 do: 
			[:wx | 
			w := wx.
			w stock do: 
					[:vx | 
					v := vx.
					offreLC add: v]].
	offreLCTriee := offreLC asSortedCollection: [:a :b | a first < b first].
	prixEtudies := OrderedCollection new.
	offreLCTriee do: 
			[:couple | 
			p := couple first.
			(prixEtudies includes: p) ifFalse: 
					[offreP := offreLCTriee select: [:c2 | c2 first <= p].
					cpt := 0.
					offreP do: [:d | cpt := cpt + d last].
					offreP2 := OrderedCollection new.
					offreP2 add: p.
					offreP2 add: cpt.
					fonctionOffreLC add: offreP2.
					prixEtudies add: p]].	"Determination du prix d'equilibre de LC2 (et eventuellement du rationnement) en utilisant une fonction 
	de D exogene"
	rationnement2 := 0.
	place := self theMarkets_Cells detect: [:f | f nom = #LC2].
	e := fonctionOffreLC detect: 
					[:gx | 
					g := gx.
					g last >= place qD]
				ifNone: [nil].
	e isNil
		ifFalse: [prix2 := e first]
		ifTrue: 
			[prix2 := fonctionOffreLC last first.
			rationnement2 := place qD - fonctionOffreLC last last].	"'Prix de LC2: ' , prix2 asFloat printString printOn: Transcript. Transcript cr.
	'Rationnement de LC2: ' , rationnement2 asFloat printString printOn: Transcript.
	Transcript cr."	"Determination des commandes des GC de LC2 (collection vente) a partir du prix d''equilibre"
	GcLc2 do: [:u | u vente: OrderedCollection new].
	fonctionOffreLC last last <= place qD
		ifTrue: 
			[GcLc2 do: 
					[:a | 
					a fonctionOffre isEmpty ifFalse: 
							[a vente add: prix2.
							a vente add: a fonctionOffre last last]]]
		ifFalse: 
			[cpt := 0.
			GcLc2 do: 
					[:yx | 
					y := yx.
					yy := y fonctionOffre asSortedCollection: [:a :b | a first > b first].
					yyy := yy detect: [:z | z first < prix2] ifNone: [nil].
					yyy isNil ifFalse: 
							[cpt := cpt + yyy last.
							y vente add: prix2.
							y vente add: yyy last]].
			Dresiduelle := place qD - cpt.
			cpt2 := 0.
			GcLc2 do: 
					[:d | 
					j := d stock detect: [:jj | jj first = prix2] ifNone: [nil].
					j isNil ifFalse: [cpt2 := cpt2 + j last]].
			Oresiduelle := cpt2.
			Oresiduelle >= Dresiduelle ifTrue: 
					[taux := Dresiduelle / Oresiduelle.
					GcLc2 do: 
							[:k | 
							l := k stock detect: [:kk | kk first = prix2] ifNone: [nil].
							l isNil ifFalse: 
									[k vente isEmpty
										ifTrue: 
											[k vente add: prix2.
											k vente add: l last * taux]
										ifFalse: 
											[toto := k vente last.
											k vente: OrderedCollection new.
											k vente add: prix2.
											k vente add: toto + (l last * taux)]]]]].	"cpt15 := 0.
	self theMarkets_GCs
		do: [:a | a vente isEmpty ifFalse: [cpt15 := cpt15 + a vente last]].
	'Ventes des GC: ' , cpt15 asFloat printString printOn: Transcript.
	Transcript cr."	"cpt15 := 0.
	GcLc1
		do: [:a | a vente isEmpty ifFalse: [cpt15 := cpt15 + a vente last]].
	'Ventes des GC de LC1: ' , cpt15 asFloat printString printOn: Transcript.
	Transcript cr.

cpt15 := 0.
	GcLc2
		do: [:a | a vente isEmpty ifFalse: [cpt15 := cpt15 + a vente last]].
	'Ventes des GC de LC2: ' , cpt15 asFloat printString printOn: Transcript.
	Transcript cr."	"Livraison des GC ie actualisation de leur stock"
	self theMarkets_GCs do: [:a | a livraisonCm].	"Sorties graphiques et ecran"	"cpt11 := 0.
	GcLc1 do: [:b | cpt11 := cpt11 + b stockTotal].
	self stockGC1: cpt11.
	'stock des GC de LC1: ' , cpt11 asFloat printString printOn: Transcript.
	Transcript cr.

cpt11 := 0.
	GcLc2 do: [:b | cpt11 := cpt11 + b stockTotal].
	self stockGC2: cpt11.
'stock des GC de LC2: ' , cpt11 asFloat printString printOn: Transcript.
	Transcript cr."	"cpt11 := 0.
	self theMarkets_GCs do: [:b | cpt11 := cpt11 + b stockTotal].
	'stock des GC: ' , cpt11 asFloat printString printOn: Transcript.
	Transcript cr."	"self prixGC1: prix1.
	self prixGC2: prix2.
	self rationnementGC1: rationnement1.
	self rationnementGC2: rationnement2."
	self rationnement: rationnement1 + rationnement2.	"'Rationnement: ' , self rationnement asFloat printString printOn: Transcript. Transcript cr."	"self
		prix: (prix1 * (24000 - rationnement1) + (prix2 * (9000 - rationnement2)))
				/ (33000 - self rationnement)."	" ************************************************INDICATEURS DE RESULTATS*************************************************** "	"Determination du stock residuel dans les LC"
	cpt11 := 0.
	GcLc1 do: [:b | cpt11 := cpt11 + b stockTotal].
	self stockGC1: cpt11.
	cpt11 := 0.
	GcLc2 do: [:b | cpt11 := cpt11 + b stockTotal].
	self stockGC2: cpt11.
	stockdesLC := self stockGC1 + self stockGC2.	"Determination du stock residuel dans les LR"
	cpt7 := 0.
	GP1 do: [:b | cpt7 := cpt7 + b stockTotal].
	cpt30 := 0.
	GP2 do: [:b | cpt7 := cpt30 + b stockTotal].
	cpt31 := 0.
	GP3 do: [:b | cpt7 := cpt31 + b stockTotal].
	stockdesLR := cpt7 + cpt30 + cpt31.	"Calcul des indicateurs de mauvaise allocation des ressources"
	rationnement > 0 ifTrue: 
			[stockdesLR > 0
				ifTrue: [self mauvaiseAllocationLRLC: self mauvaiseAllocationLCLC + 1]].
	rationnement > 0 ifTrue: 
			[stockdesLC > 0
				ifTrue: [self mauvaiseAllocationLCLC: self mauvaiseAllocationLCLC + 1]].
	self rationnementTotal: self rationnementTotal + rationnement.
	self rationnementTotal1: self rationnementTotal1 + rationnement1.
	self rationnementTotal2: self rationnementTotal2 + rationnement2.
	cpt := 0.
	self listePrixLC1 add: prix1.
	self listePrixLC1 do: [:a | cpt := cpt + a].
	prixMoyenLC1 := cpt / 100.
	cpt := 0.
	self listePrixLC1
		do: [:a | cpt := cpt + ((a - prixMoyenLC1) * (a - prixMoyenLC1))].
	variabilitePrixLC1 := (cpt / 100) sqrt.
	cpt := 0.
	self listePrixLC2 add: prix2.
	self listePrixLC2 do: [:a | cpt := cpt + a].
	prixMoyenLC2 := cpt / 100.
	cpt := 0.
	self listePrixLC2
		do: [:a | cpt := cpt + ((a - prixMoyenLC2) * (a - prixMoyenLC2))].
	variabilitePrixLC2 := (cpt / 100) sqrt.
	cpt := 0.
	self listePrix
		add: (prix1 * (30000 - rationnement1) + (prix2 * (30000 - rationnement2)))
				/ (60000 - self rationnement).
	self listePrix do: [:a | cpt := cpt + a].
	self prixMoyen: cpt / 100.	"self variabilitePrix: ((variabilitePrixLC1 * (2400000 - rationnementTotal1) + (variabilitePrixLC2 * (900000 - rationnementTotal2))) / (3300000 - self rationnementTotal))."
	self variabilitePrix: (variabilitePrixLC1 + variabilitePrixLC2) / 2.
	t = 100 ifTrue: 
			[self prixMoyen asFloat printOn: Transcript.
			' ; ' printString printOn: Transcript.
			prixMoyenLC1 asFloat printOn: Transcript.
			' ; ' printString printOn: Transcript.
			prixMoyenLC2 asFloat printOn: Transcript.
			' ; ' printString printOn: Transcript.
			self rationnementTotal asFloat printOn: Transcript.
			' ; ' printString printOn: Transcript.
			self rationnementTotal1 asFloat printOn: Transcript.
			' ; ' printString printOn: Transcript.
			self rationnementTotal2 asFloat printOn: Transcript.
			' ; ' printString printOn: Transcript.
			self mauvaiseAllocationLRLC asFloat printOn: Transcript.
			' ; ' printString printOn: Transcript.
			self mauvaiseAllocationLCLC asFloat printOn: Transcript.
			' ; ' printString printOn: Transcript.
			self variabilitePrix asFloat printOn: Transcript.
			' ; ' printString printOn: Transcript.
			variabilitePrixLC1 asFloat printOn: Transcript.
			' ; ' printString printOn: Transcript.
			variabilitePrixLC2 asFloat printOn: Transcript.
			Transcript cr].
	Transcript flush.
	self updateData: t!

evoluateReseauxCm: t nFois: n
	"I- ACTUALISATION DU STOCK DES GP (APPROVISIONNEMENT EXOGENE)"

	| GcLc1 offreP2 p offreP cpt place e y yy yyy Dresiduelle cpt2 j Oresiduelle taux l offreLC offreLCTriee fonctionOffreLC GcLc2 o prixEtudies cpt7 cpt8 cpt10 cpt11 prix1 rationnement1 prix2 rationnement2 w v toto GP1 GP2 GP3 copieGC g gc prixMoyenLC1 variabilitePrixLC1 prixMoyenLC2 variabilitePrixLC2 stockdesLC cpt30 cpt31 stockdesLR file |
	cpt8 := 0.
	self theMarkets_Cells do: [:a | a aleaZone: (Cormas randomFrom: 1 to: 9)].
	self theMarkets_GPs do: 
			[:a | 
			a aleaIndividuel: (Cormas randomFrom: 1 to: 9).
			o := OrderedCollection new.
			o add: 250 - (10 * a patch aleaZone) - (10 * a aleaIndividuel).
			o add: 2400 + (160 * a patch aleaZone) + (160 * a aleaIndividuel).
			a achat: o.
			cpt8 := cpt8 + a achat last.
			a receptionMarchandises].	"'Approvisonnement des GP: ' , cpt8 asFloat printString printOn: Transcript.
	Transcript cr.
	cpt6 := 0.
	self theMarkets_GPs do: [:b | cpt6 := cpt6 + b stockTotal].
	self stockGP: cpt6.
	'Stock des GP avant vente aux GC: ' , self stockGP asFloat printString printOn: Transcript.
	Transcript cr.
	cpt11 := 0.
	self theMarkets_GCs do: [:b | cpt11 := cpt11 + b stockTotal].
	self stockGC: cpt11.
	'stock des GC avant achat aux GP: ' , self stockGC asFloat printString printOn: Transcript. 	Transcript cr."
	GP1 := self theMarkets_GPs select: [:z | z lieu = #LR1].
	GP2 := self theMarkets_GPs select: [:z | z lieu = #LR2].
	GP3 := self theMarkets_GPs select: [:z | z lieu = #LR3].
	cpt11 := 0.
	GP1 do: [:b | cpt11 := cpt11 + b stockTotal].
	self stockGP1: cpt11.
	cpt11 := 0.
	GP2 do: [:b | cpt11 := cpt11 + b stockTotal].
	self stockGP2: cpt11.
	cpt11 := 0.
	GP3 do: [:b | cpt11 := cpt11 + b stockTotal].
	self stockGP3: cpt11.	"II- PROCESSUS DE MARCHE ENTRE GP et GC"
	cpt7 := 0.
	cpt10 := 0.
	copieGC := OrderedCollection new.
	copieGC addAll: self theMarkets_GCs.
	1 to: 30
		do: 
			[:i | 
			g := Cormas randomFrom: 1 to: 31 - i.
			gc := copieGC at: g.
			gc sendBid.
			gc listeGP do: [:b | b sendOfferCm].
			gc sendContract.
			gc listeGP do: [:b | b sendOfferCm].
			gc sendContract2.
			cpt10 := cpt10 + gc achatTotal.
			gc listeGP do: 
					[:c | 
					c lectureCommandes.
					c vente isEmpty ifFalse: [cpt7 := cpt7 + c vente last].
					c livraisonCm].
			gc receptionMarchandises.
			copieGC remove: gc].	"ventesGP := cpt7.
	'ventes des GP: ' , ventesGP asFloat printString printOn: Transcript.
	Transcript cr.
	cpt9 := 0.
	self theMarkets_GPs do: [:b | cpt9 := cpt9 + b stockTotal].
	stockGPbis := cpt9.
	'stock des GP apres vente aux GC: ' , stockGPbis asFloat printString printOn: Transcript.
	Transcript cr.
	achatGC := cpt10.
	'achat des GC: ' , achatGC asFloat printString printOn: Transcript.
	Transcript cr.
	cpt5 := 0.
	self theMarkets_GCs do: [:b | cpt5 := cpt5 + b stockTotal].
	self stockGC: cpt5.
	'stock des GC apres achat aux GP: ' , self stockGC asFloat printString printOn: Transcript.
	Transcript cr."	"III- PROCESSUS DE MARCHE EN AVAL DES GC (DANS LES LC)"	"Determination des offres individuelles des GP"
	self theMarkets_GCs do: [:a | a supplyCm].	"Determination de la fonction d'offre de LC1"
	GcLc1 := self theMarkets_GCs select: [:z | z lieu = #LC1].
	offreLC := OrderedCollection new.
	offreLCTriee := OrderedCollection new.
	fonctionOffreLC := OrderedCollection new.
	GcLc1 do: 
			[:wx | 
			w := wx.
			w stock do: 
					[:vx | 
					v := vx.
					offreLC add: v]].
	offreLCTriee := offreLC asSortedCollection: [:a :b | a first < b first].
	prixEtudies := OrderedCollection new.
	offreLCTriee do: 
			[:couple | 
			p := couple first.
			(prixEtudies includes: p) ifFalse: 
					[offreP := offreLCTriee select: [:c2 | c2 first <= p].
					cpt := 0.
					offreP do: [:d | cpt := cpt + d last].
					offreP2 := OrderedCollection new.
					offreP2 add: p.
					offreP2 add: cpt.
					fonctionOffreLC add: offreP2.
					prixEtudies add: p]].	"Determination du prix d'equilibre de LC1 (et eventuellement du rationnement) en utilisant une fonction 
	de D exogene"
	rationnement1 := 0.
	place := self theMarkets_Cells detect: [:f | f nom = #LC1].
	e := fonctionOffreLC detect: 
					[:gx | 
					g := gx.
					g last >= place qD]
				ifNone: [nil].
	e isNil
		ifFalse: [prix1 := e first]
		ifTrue: 
			[prix1 := fonctionOffreLC last first.
			rationnement1 := place qD - fonctionOffreLC last last].	"'Prix de LC1: ' , prix1 asFloat printString printOn: Transcript. Transcript cr.
	'Rationnement de LC1: ' , rationnement1 asFloat printString printOn: Transcript.
	Transcript cr."	"Determination des commandes des GC de LC1 (collection vente) a partir du prix d''equilibre"
	GcLc1 do: [:u | u vente: OrderedCollection new].
	fonctionOffreLC last last <= place qD
		ifTrue: 
			[GcLc1 do: 
					[:a | 
					a fonctionOffre isEmpty ifFalse: 
							[a vente add: prix1.
							a vente add: a fonctionOffre last last]]]
		ifFalse: 
			[cpt := 0.
			GcLc1 do: 
					[:yx | 
					y := yx.
					yy := y fonctionOffre asSortedCollection: [:a :b | a first > b first].
					yyy := yy detect: [:z | z first < prix1] ifNone: [nil].
					yyy isNil ifFalse: 
							[cpt := cpt + yyy last.
							y vente add: prix1.
							y vente add: yyy last]].
			Dresiduelle := place qD - cpt.
			cpt2 := 0.
			GcLc1 do: 
					[:d | 
					j := d stock detect: [:jj | jj first = prix1] ifNone: [nil].
					j isNil ifFalse: [cpt2 := cpt2 + j last]].
			Oresiduelle := cpt2.
			Oresiduelle >= Dresiduelle ifTrue: 
					[taux := Dresiduelle / Oresiduelle.
					GcLc1 do: 
							[:k | 
							l := k stock detect: [:kk | kk first = prix1] ifNone: [nil].
							l isNil ifFalse: 
									[k vente isEmpty
										ifTrue: 
											[k vente add: prix1.
											k vente add: l last * taux]
										ifFalse: 
											[toto := k vente last.
											k vente: OrderedCollection new.
											k vente add: prix1.
											k vente add: toto + (l last * taux)]]]]].	"Determination de la fonction d'offre de LC2"
	GcLc2 := self theMarkets_GCs select: [:z | z lieu = #LC2].
	offreLC := OrderedCollection new.
	offreLCTriee := OrderedCollection new.
	fonctionOffreLC := OrderedCollection new.
	GcLc2 do: 
			[:wx | 
			w := wx.
			w stock do: 
					[:vx | 
					v := vx.
					offreLC add: v]].
	offreLCTriee := offreLC asSortedCollection: [:a :b | a first < b first].
	prixEtudies := OrderedCollection new.
	offreLCTriee do: 
			[:couple | 
			p := couple first.
			(prixEtudies includes: p) ifFalse: 
					[offreP := offreLCTriee select: [:c2 | c2 first <= p].
					cpt := 0.
					offreP do: [:d | cpt := cpt + d last].
					offreP2 := OrderedCollection new.
					offreP2 add: p.
					offreP2 add: cpt.
					fonctionOffreLC add: offreP2.
					prixEtudies add: p]].	"Determination du prix d'equilibre de LC2 (et eventuellement du rationnement) en utilisant une fonction 
	de D exogene"
	rationnement2 := 0.
	place := self theMarkets_Cells detect: [:f | f nom = #LC2].
	e := fonctionOffreLC detect: 
					[:gx | 
					g := gx.
					g last >= place qD]
				ifNone: [nil].
	e isNil
		ifFalse: [prix2 := e first]
		ifTrue: 
			[prix2 := fonctionOffreLC last first.
			rationnement2 := place qD - fonctionOffreLC last last].	"'Prix de LC2: ' , prix2 asFloat printString printOn: Transcript. Transcript cr.
	'Rationnement de LC2: ' , rationnement2 asFloat printString printOn: Transcript.
	Transcript cr."	"Determination des commandes des GC de LC2 (collection vente) a partir du prix d''equilibre"
	GcLc2 do: [:u | u vente: OrderedCollection new].
	fonctionOffreLC last last <= place qD
		ifTrue: 
			[GcLc2 do: 
					[:a | 
					a fonctionOffre isEmpty ifFalse: 
							[a vente add: prix2.
							a vente add: a fonctionOffre last last]]]
		ifFalse: 
			[cpt := 0.
			GcLc2 do: 
					[:yx | 
					y := yx.
					yy := y fonctionOffre asSortedCollection: [:a :b | a first > b first].
					yyy := yy detect: [:z | z first < prix2] ifNone: [nil].
					yyy isNil ifFalse: 
							[cpt := cpt + yyy last.
							y vente add: prix2.
							y vente add: yyy last]].
			Dresiduelle := place qD - cpt.
			cpt2 := 0.
			GcLc2 do: 
					[:d | 
					j := d stock detect: [:jj | jj first = prix2] ifNone: [nil].
					j isNil ifFalse: [cpt2 := cpt2 + j last]].
			Oresiduelle := cpt2.
			Oresiduelle >= Dresiduelle ifTrue: 
					[taux := Dresiduelle / Oresiduelle.
					GcLc2 do: 
							[:k | 
							l := k stock detect: [:kk | kk first = prix2] ifNone: [nil].
							l isNil ifFalse: 
									[k vente isEmpty
										ifTrue: 
											[k vente add: prix2.
											k vente add: l last * taux]
										ifFalse: 
											[toto := k vente last.
											k vente: OrderedCollection new.
											k vente add: prix2.
											k vente add: toto + (l last * taux)]]]]].	"cpt15 := 0.
	self theMarkets_GCs
		do: [:a | a vente isEmpty ifFalse: [cpt15 := cpt15 + a vente last]].
	'Ventes des GC: ' , cpt15 asFloat printString printOn: Transcript.
	Transcript cr."	"cpt15 := 0.
	GcLc1
		do: [:a | a vente isEmpty ifFalse: [cpt15 := cpt15 + a vente last]].
	'Ventes des GC de LC1: ' , cpt15 asFloat printString printOn: Transcript.
	Transcript cr.

cpt15 := 0.
	GcLc2
		do: [:a | a vente isEmpty ifFalse: [cpt15 := cpt15 + a vente last]].
	'Ventes des GC de LC2: ' , cpt15 asFloat printString printOn: Transcript.
	Transcript cr."	"Livraison des GC ie actualisation de leur stock"
	self theMarkets_GCs do: [:a | a livraisonCm].	"Sorties graphiques et ecran"	"cpt11 := 0.
	GcLc1 do: [:b | cpt11 := cpt11 + b stockTotal].
	self stockGC1: cpt11.
	'stock des GC de LC1: ' , cpt11 asFloat printString printOn: Transcript.
	Transcript cr.

cpt11 := 0.
	GcLc2 do: [:b | cpt11 := cpt11 + b stockTotal].
	self stockGC2: cpt11.
'stock des GC de LC2: ' , cpt11 asFloat printString printOn: Transcript.
	Transcript cr."	"cpt11 := 0.
	self theMarkets_GCs do: [:b | cpt11 := cpt11 + b stockTotal].
	'stock des GC: ' , cpt11 asFloat printString printOn: Transcript.
	Transcript cr."	"self prixGC1: prix1.
	self prixGC2: prix2.
	self rationnementGC1: rationnement1.
	self rationnementGC2: rationnement2."
	self rationnement: rationnement1 + rationnement2.	"'Rationnement: ' , self rationnement asFloat printString printOn: Transcript. Transcript cr."	"self
		prix: (prix1 * (24000 - rationnement1) + (prix2 * (9000 - rationnement2)))
				/ (33000 - self rationnement)."	" ************************************************INDICATEURS DE RESULTATS*************************************************** "	"Determination du stock residuel dans les LC"
	cpt11 := 0.
	GcLc1 do: [:b | cpt11 := cpt11 + b stockTotal].
	self stockGC1: cpt11.
	cpt11 := 0.
	GcLc2 do: [:b | cpt11 := cpt11 + b stockTotal].
	self stockGC2: cpt11.
	stockdesLC := self stockGC1 + self stockGC2.	"Determination du stock residuel dans les LR"
	cpt7 := 0.
	GP1 do: [:b | cpt7 := cpt7 + b stockTotal].
	cpt30 := 0.
	GP2 do: [:b | cpt7 := cpt30 + b stockTotal].
	cpt31 := 0.
	GP3 do: [:b | cpt7 := cpt31 + b stockTotal].
	stockdesLR := cpt7 + cpt30 + cpt31.	"Calcul des indicateurs de mauvaise allocation des ressources"
	rationnement > 0 ifTrue: 
			[stockdesLR > 0
				ifTrue: [self mauvaiseAllocationLRLC: self mauvaiseAllocationLCLC + 1]].
	rationnement > 0 ifTrue: 
			[stockdesLC > 0
				ifTrue: [self mauvaiseAllocationLCLC: self mauvaiseAllocationLCLC + 1]].
	self rationnementTotal: self rationnementTotal + rationnement.
	self rationnementTotal1: self rationnementTotal1 + rationnement1.
	self rationnementTotal2: self rationnementTotal2 + rationnement2.
	cpt := 0.
	self listePrixLC1 add: prix1.
	self listePrixLC1 do: [:a | cpt := cpt + a].
	prixMoyenLC1 := cpt / 100.
	cpt := 0.
	self listePrixLC1
		do: [:a | cpt := cpt + ((a - prixMoyenLC1) * (a - prixMoyenLC1))].
	variabilitePrixLC1 := (cpt / 100) sqrt.
	cpt := 0.
	self listePrixLC2 add: prix2.
	self listePrixLC2 do: [:a | cpt := cpt + a].
	prixMoyenLC2 := cpt / 100.
	cpt := 0.
	self listePrixLC2
		do: [:a | cpt := cpt + ((a - prixMoyenLC2) * (a - prixMoyenLC2))].
	variabilitePrixLC2 := (cpt / 100) sqrt.
	cpt := 0.
	self listePrix
		add: (prix1 * (30000 - rationnement1) + (prix2 * (30000 - rationnement2)))
				/ (60000 - self rationnement).
	self listePrix do: [:a | cpt := cpt + a].
	self prixMoyen: cpt / 100.	"self variabilitePrix: ((variabilitePrixLC1 * (2400000 - rationnementTotal1) + (variabilitePrixLC2 * (900000 - rationnementTotal2))) / (3300000 - self rationnementTotal))."
	self variabilitePrix: (variabilitePrixLC1 + variabilitePrixLC2) / 2.


t = 100 ifTrue: [ 	file := ((Cormas dataPath: self class name)
				, 'frank.txt') asFilename appendStream.	 file nextPutAll: self prixMoyen asFloat printString,';' . file nextPutAll: prixMoyenLC1 asFloat printString,';' . file nextPutAll: prixMoyenLC2 asFloat printString,';' . file nextPutAll: self rationnementTotal asFloat printString,';' . file nextPutAll: self rationnementTotal1 asFloat printString,';' . file nextPutAll: self rationnementTotal2 asFloat printString,';' . file nextPutAll: self mauvaiseAllocationLRLC asFloat printString,';' . file nextPutAll: self mauvaiseAllocationLCLC asFloat printString,';' . file nextPutAll: self variabilitePrix asFloat printString,';' . file nextPutAll: variabilitePrixLC1 asFloat printString,';' . file nextPutAll: variabilitePrixLC2 asFloat printString.
	file nextPutAll: '\' withCRs. file close].

	"t = 100 ifTrue: 
			[self prixMoyen asFloat printOn: Transcript.
			' ; ' printString printOn: Transcript.
			prixMoyenLC1 asFloat printOn: Transcript.
			' ; ' printString printOn: Transcript.
			prixMoyenLC2 asFloat printOn: Transcript.
			' ; ' printString printOn: Transcript.
			self rationnementTotal asFloat printOn: Transcript.
			' ; ' printString printOn: Transcript.
			self rationnementTotal1 asFloat printOn: Transcript.
			' ; ' printString printOn: Transcript.
			self rationnementTotal2 asFloat printOn: Transcript.
			' ; ' printString printOn: Transcript.
			self mauvaiseAllocationLRLC asFloat printOn: Transcript.
			' ; ' printString printOn: Transcript.
			self mauvaiseAllocationLCLC asFloat printOn: Transcript.
			' ; ' printString printOn: Transcript.
			self variabilitePrix asFloat printOn: Transcript.
			' ; ' printString printOn: Transcript.
			variabilitePrixLC1 asFloat printOn: Transcript.
			' ; ' printString printOn: Transcript.
			variabilitePrixLC2 asFloat printOn: Transcript.
			Transcript cr]."
	Transcript flush.
	self updateData: t! !

!CormasNS.Models.Markets.Markets methodsFor: 'accessing'!

listePrix
	^listePrix!

listePrix: anObject
	listePrix := anObject!

listePrixLC1
	^listePrixLC1!

listePrixLC1: anObject
	listePrixLC1 := anObject!

listePrixLC2
	^listePrixLC2!

listePrixLC2: anObject
	listePrixLC2 := anObject!

mauvaiseAllocationLCLC
	^mauvaiseAllocationLCLC!

mauvaiseAllocationLCLC: anObject
	mauvaiseAllocationLCLC := anObject!

mauvaiseAllocationLRLC
	^mauvaiseAllocationLRLC!

mauvaiseAllocationLRLC: anObject
	mauvaiseAllocationLRLC := anObject!

prix
	^prix!

prix: anObject
	prix := anObject!

prixGC1
	^prixGC1!

prixGC1: anObject
	prixGC1 := anObject!

prixGC2
	^prixGC2!

prixGC2: anObject
	prixGC2 := anObject!

prixMoyen
	^prixMoyen!

prixMoyen: anObject
	prixMoyen := anObject!

rationnement
	^rationnement!

rationnement: anObject
	rationnement := anObject!

rationnementGC1
	^rationnementGC1!

rationnementGC1: anObject
	rationnementGC1 := anObject!

rationnementGC2
	^rationnementGC2!

rationnementGC2: anObject
	rationnementGC2 := anObject!

rationnementTotal
	^rationnementTotal!

rationnementTotal1
	^rationnementTotal1!

rationnementTotal1: anObject
	rationnementTotal1 := anObject!

rationnementTotal2
	^rationnementTotal2!

rationnementTotal2: anObject
	rationnementTotal2 := anObject!

rationnementTotal: anObject
	rationnementTotal := anObject!

stockGC
	^stockGC!

stockGC1
	^stockGC1!

stockGC1: anObject
	stockGC1 := anObject!

stockGC2
	^stockGC2!

stockGC2: anObject
	stockGC2 := anObject!

stockGC: anObject
	stockGC := anObject!

stockGP
	^stockGP!

stockGP1
	^stockGP1!

stockGP1: anObject
	stockGP1 := anObject!

stockGP2
	^stockGP2!

stockGP2: anObject
	stockGP2 := anObject!

stockGP3
	^stockGP3!

stockGP3: anObject
	stockGP3 := anObject!

stockGP: anObject
	stockGP := anObject!

theMarkets_Cells
^theMarkets_Cells!

theMarkets_Cells: x
theMarkets_Cells := x!

theMarkets_GCs
^theMarkets_GCs!

theMarkets_GCs: x
theMarkets_GCs := x!

theMarkets_GPs
^theMarkets_GPs!

theMarkets_GPs: x
theMarkets_GPs := x!

variabilitePrix
	^variabilitePrix!

variabilitePrix: anObject
	variabilitePrix := anObject! !

!CormasNS.Models.Markets.Markets methodsFor: 'probes'!

prixGlobal
"return the data (a number) to be plotted with the prixGlobal chart"
^self prix!

prixLC1
	"return the data (a number) to be plotted with the prixLC1 chart"

	^prixGC1!

prixLC2
	"return the data (a number) to be plotted with the prixLC2 chart"

	^prixGC2!

rationnementLC
"return the data (a number) to be plotted with the rationnementLC chart"
^self rationnement!

rationnementLC1
	"return the data (a number) to be plotted with the rationnementLC1 chart"

	^rationnementGC1!

rationnementLC2
	"return the data (a number) to be plotted with the rationnementLC2 chart"

	^rationnementGC2!

stockLC
"return the data (a number) to be plotted with the stockLC chart"
^self stockGC!

stockLC1
	"return the data (a number) to be plotted with the stockLC1 chart"

	^stockGC1!

stockLC2
	"return the data (a number) to be plotted with the stockLC2 chart"

	^stockGC2!

stockLR
"return the data (a number) to be plotted with the stockLR chart"
^self stockGP!

stockLR1
	"return the data (a number) to be plotted with the stockLR1 chart"

	^stockGP1!

stockLR2
	"return the data (a number) to be plotted with the stockLR2 chart"

	^stockGP2!

stockLR3
	"return the data (a number) to be plotted with the stockLR3 chart"

	^stockGP3! !


CormasNS.Models.Markets defineClass: #Markets_Cell
	superclass: #{CormasNS.Kernel.SpatialEntityElement}
	indexedType: #none
	private: false
	instanceVariableNames: 'nom coutDeplacement coutTransport qD grossistesResidents type aleaZone '
	classInstanceVariableNames: ''
	imports: ''
	category: 'Cormas-Markets'!

CormasNS.Models.Markets.Markets_Cell defineSharedVariable: #CurrentId
	private: false
	constant: false
	category: 'As yet unclassified'
	initializer: nil!

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!


!CormasNS.Models.Markets.Markets_Cell class methodsFor: 'id'!

CurrentId
	^CurrentId isNil 
		ifTrue: [0] 
		ifFalse: [CurrentId]!

CurrentId: x
	^CurrentId := x! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!


!CormasNS.Models.Markets.Markets_Cell methodsFor: 'init'!

initId
	self id: (self class CurrentId: self class CurrentId + 1)!

initValeurs
	| coutLR |

	self qD: 0.
	self nom = #LC1
		ifTrue: 
			["Information des LC sur leur demande qD et leurs couts de deplacement jusqu'aux 
			differentes LR"
			self qD: 30000.
			coutDeplacement := OrderedCollection new.
			coutLR := OrderedCollection new.
			coutLR add: #LR1.
			coutLR add: 1500.
			coutDeplacement add: coutLR.
			coutLR := OrderedCollection new.
			coutLR add: #LR2.
			coutLR add: 4000.
			coutDeplacement add: coutLR.
			coutLR := OrderedCollection new.
			coutLR add: #LR3.
			coutLR add: 8000.
			coutDeplacement add: coutLR]
		ifFalse: [self nom = #LC2
				ifTrue: 
					[self qD: 30000.
					coutDeplacement := OrderedCollection new.
					coutLR := OrderedCollection new.
					coutLR add: #LR1.
					coutLR add: 9000.
					coutDeplacement add: coutLR.
					coutLR := OrderedCollection new.
					coutLR add: #LR2.
					coutLR add: 3500.
					coutDeplacement add: coutLR.
					coutLR := OrderedCollection new.
					coutLR add: #LR3.
					coutLR add: 1000.
					coutDeplacement add: coutLR]]! !

!CormasNS.Models.Markets.Markets_Cell methodsFor: 'accessing'!

aleaZone
	^aleaZone!

aleaZone: anObject
	aleaZone := anObject!

coutDeplacement
	^coutDeplacement!

coutDeplacement: anObject
	coutDeplacement := anObject!

coutTransport
	^coutTransport!

coutTransport: anObject
	coutTransport := anObject!

grossistesResidents
	^grossistesResidents!

grossistesResidents: anObject
	grossistesResidents := anObject!

nom
	^nom!

nom: anObject
	nom := anObject!

qD
	^qD!

qD: anObject
	qD := anObject!

type
	^type!

type: anObject
	type := anObject! !


